package org.eclipse.otif.generictooladaptor;

/**
 * @author lang
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Document {

	public int key;

	public String name;
	public String version;
	public String remarks;
	public long keepAlive;
	public long docId;
	public long subscriptionId;
	
	Document(Document doc) {
		this.name = doc.name;
		this.version = doc.version;
		this.remarks = doc.remarks;
		this.keepAlive = doc.keepAlive;
		this.docId = doc.docId;
		this.subscriptionId = doc.subscriptionId;	
		this.key = doc.key;
	}

	Document(String name, String version, String remarks, 
		long keepAlive, long docId, long subscriptionId, int key) {
		this.name = name;
		this.version = version;
		this.remarks = remarks;
		this.keepAlive = System.currentTimeMillis()/1000 + keepAlive;
		this.docId = docId;
		this.subscriptionId = subscriptionId;	
		this.key = key;
	}

	private static int offset = 0;
	public static Document[] remote_documents;

	public static Document find_key(int key) {
		for(int i=0; i<remote_documents.length; i++) {
			if (key==remote_documents[i].key) return remote_documents[i];
		}
		return null;
	}

	public static void putDocument(Document doc) {
		if (remote_documents!=null) {
			Document[] temp = remote_documents;
			remote_documents = new Document[offset+1];
			for(int i=0; i<temp.length; i++) {
				remote_documents[i] = new Document(temp[i]);
			}
		} else {
			remote_documents = new Document[offset+1];
		}
		
		remote_documents[offset++] = new Document(doc);
	}

	public static void removeDocument(Document doc) {
		Document[] temp = remote_documents;
		remote_documents = new Document[offset-1];
		for(int i=0, j=0; i<temp.length; i++, j++) {
			if (doc.key == temp[i].key) {
				j--;
				offset--;
				continue;
			}
			remote_documents[j] = new Document(temp[i]);
		}
	}

	public static void removeAll() {
		if (remote_documents==null) return;
		for(int i=0; i<remote_documents.length; i++) {
			remote_documents[i] = null;
		}
		remote_documents = null;
		offset = 0;
	}
}
