package org.eclipse.otif.generictooladaptor;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.dnd.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.*;
//import org.eclipse.swt.ole.win32.*;
import org.eclipse.jface.dialogs.*;
import org.eclipse.core.resources.*;
import org.eclipse.core.runtime.*;
import java.io.*;

/**
 * @author lang
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Layout extends Thread {

	public static Composite parent = null;
	public static Composite displayArea;
	public static Composite settingArea;

	private static Menu paradigm_menu;
	public static Table paradigms_table;
	public static Table datanetworks_table;
	public static Table ta_types_table;

	public static Text working_directory_text;
	public static Button notification_check;
//	public static Text naming_service_text;
	public static String xslt_script_path;

	public Label status_text;

	private Main main;
	private MenuItem unsubscribe_mi;

	// Create main layout
	Layout(Main m) {
		this.main = m;

		GridLayout layout = new GridLayout();
		parent.setLayout(layout);

		// Create the Workspace tab item
		TabFolder tabfolder = new TabFolder(parent, SWT.NONE);
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.verticalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		tabfolder.setLayoutData(gridData);
		TabItem tabitem = new TabItem(tabfolder, SWT.BORDER);
		tabitem.setText("Workspace");

		displayArea = new Composite(tabfolder, SWT.NONE);
		layout = new GridLayout();
		layout.numColumns = 2;
		displayArea.setLayout(layout);

		Composite datanetworks = new Composite(displayArea, SWT.NONE);		
		Composite paradigms = new Composite(displayArea, SWT.NONE);		
		createDatanetworks(datanetworks);
		createSubscribeParadigms(paradigms);

		tabitem.setControl(displayArea);

		// Create the Settings tab item
		tabitem = new TabItem(tabfolder, SWT.BORDER);
		tabitem.setText("Settings");

		settingArea = new Composite(tabfolder, SWT.NONE);
		layout = new GridLayout();
		layout.numColumns = 3;
		settingArea.setLayout(layout);
		
		Composite settings_place = new Composite(settingArea, SWT.NONE);
		Composite types_place = new Composite(settingArea, SWT.NONE);
		Composite about_button = new Composite(settingArea, SWT.NONE);
		createSettingsPlace(settings_place);
		createTypesPlace(types_place);
		createAboutButton(about_button);

		tabitem.setControl(settingArea);

		Composite status_line = new Composite(parent, SWT.NONE);
		layout = new GridLayout();
		layout.numColumns = 2;
		status_line.setLayout(layout);

		Label label = new Label(status_line, SWT.NONE);
		label.setText("GTA status:");
		status_text = new Label(status_line, SWT.NONE);

		GridData griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.grabExcessHorizontalSpace = true;
		griddata.widthHint = GridData.GRAB_HORIZONTAL;
		status_text.setLayoutData(griddata);
	}

	public static void setParent(Composite p) {
		parent = p;		
	}

	public static void running() {
		datanetworks_table.getDisplay().syncExec(new Runnable() {
			public void run() {
				TableItem[] items = datanetworks_table.getItems();

				for(int i=0; i<items.length; i++) {
					Document doc = Document.find_key(items[i].hashCode());

					long now = System.currentTimeMillis()/1000;
					if (doc.keepAlive < now) {
						datanetworks_table.remove(i);
						Document.removeDocument(doc);
					} else {
						long diff = doc.keepAlive - now;
						long sec = diff % 60;
						long d_min = diff / 60;
						long min = d_min % 60;
						long hour = d_min / 60;
						String strs[];
						if (hour>0) strs = new String[]{doc.name, doc.version, hour + "h " + min + "min " + sec + "sec", doc.remarks};
						else if (min>0) strs = new String[]{doc.name, doc.version, min + "min " + sec + "sec", doc.remarks};
						else strs = new String[]{doc.name, doc.version, sec + "sec", doc.remarks};
						items[i].setText(strs);
					}
				}				
			}
		});
	}

	public void run() {
		while (true) {
			try {
				Thread.sleep(1000);
				running();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	public static boolean getNotificationCheck() {
		return notification_check.getSelection();
	}

	public void buildParadigmMenu() {
		paradigm_menu = new Menu(paradigms_table);
		MenuItem subscribe_mi = new MenuItem(paradigm_menu, SWT.CASCADE);
		subscribe_mi.setText("Subscribe to");
		new MenuItem(paradigm_menu, SWT.SEPARATOR);
		MenuItem unsubscribe_mi = new MenuItem(paradigm_menu, SWT.PUSH);
		unsubscribe_mi.setText("Unsubscribe");
		unsubscribe_mi.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent e) {};
			public void widgetSelected(SelectionEvent e) {
				if (((MenuItem)e.widget).getText().equals("Unsubscribe") && paradigms_table.getSelectionIndex() != -1) {
					TableItem[] selected = paradigms_table.getSelection();
					Paradigm par = Paradigm.find_tablekey(selected[0].hashCode());
					par.removeTableKey(selected[0].hashCode());
					paradigms_table.remove(paradigms_table.getSelectionIndex());

					// invoke unsubscribeParadigm	
					Main.backplane.unsubscribeParadigm(par.name, par.version);
				}
			}
		});

		if (Paradigm.remote_paradigms!=null) {
			Menu sub_menu = new Menu(paradigm_menu);
			for(int i=0; i<Paradigm.remote_paradigms.length; i++) {
				MenuItem mi = new MenuItem(sub_menu, SWT.PUSH);
				mi.setText(Paradigm.remote_paradigms[i].name + " v" + Paradigm.remote_paradigms[i].version);
				Paradigm.remote_paradigms[i].key = mi.hashCode();
				mi.addSelectionListener(new SelectionListener() {
					public void widgetDefaultSelected(SelectionEvent e) {};
					public void widgetSelected(SelectionEvent e) {
						Paradigm par = Paradigm.find_key(e.widget.hashCode());

						// invoke subscribeParadigm	
						Main.backplane.subscribeParadigm(par);
					}
				});
			}
			subscribe_mi.setMenu(sub_menu);
		}

		paradigms_table.setMenu(paradigm_menu);
	}	

	public static Shell getShell() {
		return parent.getShell();	
	}

	class Validator implements IInputValidator {
		public String isValid(String text) {
			return null;	
		}
	}

	// Create "Available datanetworks"
	private void createDatanetworks(Composite area) {
		GridLayout gridLayout = new GridLayout();
		area.setLayout(gridLayout);

		Label label = new Label(area, SWT.NONE);
		label.setText("Available documents:");

		datanetworks_table = new Table (area, SWT.BORDER + SWT.H_SCROLL + SWT.V_SCROLL + SWT.SINGLE);
		datanetworks_table.setLinesVisible (false);
		datanetworks_table.setToolTipText("Drop a file to publish");
		datanetworks_table.setHeaderVisible(true);
		GridData griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.verticalAlignment = GridData.FILL;
		griddata.grabExcessHorizontalSpace = true;
		griddata.grabExcessVerticalSpace = true;
		datanetworks_table.setLayoutData(griddata);

		// Create datanetwork menu
		Menu datanetwork_menu = new Menu(datanetworks_table);
		MenuItem fetch_mi = new MenuItem(datanetwork_menu, SWT.PUSH);
		fetch_mi.setText("Fetch");
		fetch_mi.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent e) {};
			// Fetch a document
			public void widgetSelected(SelectionEvent e) {
				if (datanetworks_table.getSelectionIndex()==-1) return;
				TableItem[] selected = datanetworks_table.getSelection();
				Document doc = Document.find_key(selected[0].hashCode());

				if (working_directory_text.getText() == "") {
					MessageDialog.openError(parent.getShell(), "Generic ToolAdaptor Error", "Working directory is not set!");
					return;
				}
				Path path = new Path(working_directory_text.getText());
				File fh = path.toFile();
				if (!fh.isDirectory()) {
					MessageDialog.openError(parent.getShell(), "Generic ToolAdaptor Error", "Working directory is not correct! You may set it up again.");
					return;
				}
				String filename = doc.name;

				char[] result = working_directory_text.getText().toCharArray();
				String working_directory = "";
				for(int i=0; i<result.length; i++) {
					working_directory += result[i];
					if (result[i] == '\\') working_directory += '\\';
				}

				// invoke fetchDocument	
				Main.backplane.fetchDocument(doc.subscriptionId, doc.docId, working_directory + "\\\\", filename);

				// refresh the workspace
				try {
					IWorkspaceRoot workspaceRoot = ResourcesPlugin.getWorkspace().getRoot();
					workspaceRoot.refreshLocal(IResource.DEPTH_INFINITE, null);
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		});
		new MenuItem(datanetwork_menu, SWT.SEPARATOR);
		MenuItem remove_mi = new MenuItem(datanetwork_menu, SWT.PUSH);
		remove_mi.setText("Remove");
		remove_mi.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent e) {};
			public void widgetSelected(SelectionEvent e) {
				if (datanetworks_table.getSelectionIndex()==-1) return;
				TableItem[] selected = datanetworks_table.getSelection();
				Document doc = Document.find_key(selected[0].hashCode());
				Document.removeDocument(doc);
				datanetworks_table.remove(datanetworks_table.getSelectionIndex());
			}
		});
		MenuItem remove_all_mi = new MenuItem(datanetwork_menu, SWT.PUSH);
		remove_all_mi.setText("Remove All");
		remove_all_mi.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent e) {};
			public void widgetSelected(SelectionEvent e) {
				datanetworks_table.removeAll();
				Document.removeAll();
			}
		});
		datanetworks_table.setMenu(datanetwork_menu);
		
		Transfer[] types = new Transfer[] {FileTransfer.getInstance()};
		DropTarget target = new DropTarget(area, DND.DROP_MOVE | DND.DROP_COPY);
		target.setTransfer(types);

		target.addDropListener (new DropTargetListener() {
			public void dragEnter(DropTargetEvent event) {
				event.detail = DND.DROP_COPY;	
			};
			public void dragOver(DropTargetEvent event) {
				event.detail = DND.DROP_COPY;	
			};
			public void dragLeave(DropTargetEvent event) {
				event.detail = DND.DROP_NONE;	
			};
			public void dragOperationChanged(DropTargetEvent event) {};
			public void dropAccept(DropTargetEvent event) {}
			public void drop(DropTargetEvent event) {
				// A drop has occurred, copy over the data
				if (event.data == null) { // no data to copy, indicate failure in event.detail
					event.detail = DND.DROP_NONE;
					return;
				}
				String[] file = (String[]) event.data;

				// publish the dragged and dropped files
				String files = "";
				for(int i=0; i<file.length; i++) {
					files += file[i] + "|";				
				}
				Main.backplane.publishDocument(files);
			}
 		});

		griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.verticalAlignment = GridData.FILL;
		griddata.grabExcessHorizontalSpace = true;
		griddata.grabExcessVerticalSpace = true;
		area.setLayoutData(griddata);	

		// Create the header
		TableColumn column = new TableColumn(datanetworks_table, SWT.CENTER);
		column.setText("Name");
		column.setWidth(100);
		column = new TableColumn(datanetworks_table, SWT.CENTER);
		column.setText("Version");
		column.setWidth(50);
		column = new TableColumn(datanetworks_table, SWT.CENTER);
		column.setText("Available");
		column.setWidth(100);
		column = new TableColumn(datanetworks_table, SWT.CENTER);
		column.setText("Remarks");
		column.setWidth(150);
	}

	// Create "Subscribed paradigms"
	private void createSubscribeParadigms(Composite area) {
		GridLayout gridLayout = new GridLayout();
		area.setLayout(gridLayout);

		Label label = new Label(area, SWT.NONE);
		label.setText("Paradigms subscribed to:");

		paradigms_table = new Table (area, SWT.BORDER + SWT.H_SCROLL + SWT.V_SCROLL + SWT.SINGLE + SWT.FULL_SELECTION);
		paradigms_table.setLinesVisible (false);
		paradigms_table.setHeaderVisible(true);

		GridData griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.verticalAlignment = GridData.FILL;
		griddata.grabExcessHorizontalSpace = true;
		griddata.grabExcessVerticalSpace = true;
		paradigms_table.setLayoutData(griddata);
		area.setLayoutData(griddata);	

		// Create the header
		TableColumn column = new TableColumn(paradigms_table, SWT.CENTER);
		column.setText("Name");
		column.setWidth(100);
		column = new TableColumn(paradigms_table, SWT.CENTER);
		column.setText("Version");
		column.setWidth(50);
	}

	// Create working_dir
	private Button reconnect;
	private Button login;

	// Create the ToolAdaptor type login table
	private void createTypesPlace(Composite area) {
		GridLayout layout = new GridLayout();
		area.setLayout(layout);
		
		Label label = new Label(area, SWT.NONE);
		label.setText("Please choose a tool adaptor type:");

		ta_types_table = new Table (area, SWT.BORDER + SWT.H_SCROLL + SWT.V_SCROLL + SWT.SINGLE);
		ta_types_table.setLinesVisible (false);
		ta_types_table.setHeaderVisible(true);

		// Login as the selected tooladaptor type
		ta_types_table.addMouseListener(
			new MouseListener() {
				public void mouseDoubleClick(MouseEvent e) {
					login.setEnabled(false);
					TableItem[] selected = ta_types_table.getSelection();
					if (selected.length!=1) {
						return;
					} else {
						Paradigm.unsubscribeAll();
						Main.backplane.loginToolAdaptor(selected[0].getText());
					}					
					login.setEnabled(true);
				}
				public void mouseDown(MouseEvent e) {
				}
				public void mouseUp(MouseEvent e) {
				}
			}
		);

		GridData griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.verticalAlignment = GridData.FILL;
		griddata.grabExcessHorizontalSpace = true;
		griddata.grabExcessVerticalSpace = true;
		ta_types_table.setLayoutData(griddata);

		// Create the header
		TableColumn column = new TableColumn(ta_types_table, SWT.CENTER);
		column.setText("Type");
		column.setWidth(200);

		// Login as the selected tooladaptor type
		login = new Button(area, SWT.PUSH);
		login.setText("Login as the selected type");
		login.setToolTipText("Login as the selected tooladaptor type");
		login.setEnabled(true);
		login.addListener(SWT.Selection, 
			new Listener() {
				public void handleEvent(Event e) {
					login.setEnabled(false);
					TableItem[] selected = ta_types_table.getSelection();
					if (selected.length!=1) {
						MessageDialog.openWarning(Layout.getShell(), "Warning", "A type should be selected.");
					} else {
						Paradigm.unsubscribeAll();
						Main.backplane.loginToolAdaptor(selected[0].getText());
					}					
					login.setEnabled(true);
				};
			}
		);

		griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.verticalAlignment = GridData.FILL;
		area.setLayoutData(griddata);	
	}

	private void createSettingsPlace(Composite area) {
		GridLayout layout = new GridLayout();
		area.setLayout(layout);

		Label label = new Label(area, SWT.NONE);
		label.setText("Fetched document will be stored in:\n(Drag and drop a folder from your workspace in the Eclipse navigator)");
		
		working_directory_text = new Text(area, SWT.BORDER);
		working_directory_text.setText("");
		working_directory_text.setToolTipText("Drop that directory which you want to your working directory");
		GridData griddata = new GridData();
		griddata.widthHint = 400;
		working_directory_text.setLayoutData(griddata);

		Transfer[] types = new Transfer[] {FileTransfer.getInstance()};
		DropTarget target = new DropTarget(area, DND.DROP_MOVE | DND.DROP_COPY);
		target.setTransfer(types);

		target.addDropListener (new DropTargetListener() {
			public void dragEnter(DropTargetEvent event) {
				event.detail = DND.DROP_COPY;	
			};
			public void dragOver(DropTargetEvent event) {
				event.detail = DND.DROP_COPY;	
			};
			public void dragLeave(DropTargetEvent event) {
				event.detail = DND.DROP_NONE;	
			};
			public void dragOperationChanged(DropTargetEvent event) {};
			public void dropAccept(DropTargetEvent event) {}
			public void drop(DropTargetEvent event) {
				// A drop has occurred, copy over the data
				if (event.data == null) { // no data to copy, indicate failure in event.detail
					event.detail = DND.DROP_NONE;
					return;
				}
				String[] file = (String[]) event.data;
				if (file.length != 1) {
					MessageDialog.openError(parent.getShell(), "Generic ToolAdaptor Error", "You should drop one directory.");
					return;
				}

				// publish this dragged and dropped file
				Path path = new Path(file[0]);
				File fh = path.toFile();
				if (!fh.isDirectory()) {
					MessageDialog.openError(parent.getShell(), "Generic ToolAdaptor Error", "This is not a directory.");
					return;
				}

				working_directory_text.setText(file[0]);
		}
 		});

		label = new Label(area, SWT.NONE);
		label.setText("");

		notification_check = new Button(area, SWT.CHECK);
		notification_check.setText("Notification when documents arrives");

		griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.verticalAlignment = GridData.FILL;
		griddata.grabExcessHorizontalSpace = true;
		griddata.grabExcessVerticalSpace = true;
		area.setLayoutData(griddata);	

		label = new Label(area, SWT.NONE);
		label.setText("");

//		label = new Label(area, SWT.NONE);
//		label.setText("NamingServer (format: ip_address:port_number)");
		
//		naming_service_text = new Text(area, SWT.BORDER);
//		naming_service_text.setText("");
//		naming_service_text.setToolTipText("To specify the NamingServer explicitly (format: ip_address:port_number)");
//		griddata = new GridData();
//		griddata.widthHint = 150;
//		naming_service_text.setLayoutData(griddata);

		reconnect = new Button(area, SWT.PUSH);
		reconnect.setText("Reconnect to Backplane");
		reconnect.setToolTipText("Reconnect to the Backplane server");
		reconnect.setEnabled(true);
		reconnect.addListener(SWT.Selection, 
			new Listener() {
				public void handleEvent(Event e) {
					reconnect.setEnabled(false);
					String[] args = new String[1];
					args[0] = "";
//					args[0] = naming_service_text.getText();
					Main.backplane.initialize(args);
//					if (Main.backplane.initialize(args)==0) main.backplane.default_subscribe(main.default_subscribed_paradigms);
					reconnect.setEnabled(true);
				};
			}
		);
	}

	// Create About button
	private void createAboutButton(Composite area) {
		GridLayout layout = new GridLayout();
		area.setLayout(layout);

		// Put out the "about box" button
		Button button = new Button(area, SWT.PUSH);
		button.setText(" About ");
		button.setToolTipText("About");
		GridData griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		button.setLayoutData(griddata);	
		button.setEnabled(true);
		button.addListener(SWT.Selection, 
			new Listener() {
				public void handleEvent(Event e) {
					Main.backplane.aboutBox();
				};
			}
		);

		griddata = new GridData();
		griddata.horizontalAlignment = GridData.END;
		griddata.verticalAlignment = GridData.FILL;
		area.setLayoutData(griddata);	
	}
}