package org.eclipse.otif.generictooladaptor;

/**
 * @author lang
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Paradigm {

	public static Paradigm[] remote_paradigms;

	public boolean subscribed;
	public int key;
	public int[] table_keys;
	public String name;
	public String version;
	public boolean subscribable;

	Paradigm(String name) { 
		this.name = name; 
		this.table_keys = new int[0];
		this.subscribed = false;
		this.subscribable = false;
	}

	public static Paradigm find_key(int key) {
		for(int i=0; i<remote_paradigms.length; i++) {
			if (key==remote_paradigms[i].key) return remote_paradigms[i];
		}
		return null;
	}

	public static Paradigm find_tablekey(int table_key) {
		for(int i=0; i<remote_paradigms.length; i++) {
			for(int j=0; j<remote_paradigms[i].table_keys.length; j++) {
				if (table_key==remote_paradigms[i].table_keys[j]) return remote_paradigms[i];
			}
		}
		return null;
	}

	public static Paradigm find_paradigm(String name, String version) {
		for(int i=0; i<remote_paradigms.length; i++) {
			if (remote_paradigms[i].name.compareTo(name)==0 && remote_paradigms[i].version.compareTo(version)==0)
				return remote_paradigms[i];
		}	
		return null;	
	}

	public void putTableKey(int table_key) {
		int[] temp = table_keys;
		table_keys = new int[temp.length+1];
		for(int i=0; i<temp.length; i++) {
			table_keys[i] = temp[i];
		}
		table_keys[temp.length] = table_key;
		subscribed = true;
	}

	public void removeTableKey(int table_key) {
		int[] temp = table_keys;
		table_keys = new int[temp.length-1];
		for(int i=0, j=0; i<temp.length; i++, j++) {
			if (table_key == temp[i]) {
				j--;
				continue;
			}
			table_keys[j] = temp[i];
		}

		if (table_keys.length == 0) subscribed = false;
	}

	public static void removeAll() {
		if (remote_paradigms==null) return;
		for(int i=0; i<remote_paradigms.length; i++) {
			remote_paradigms[i] = null;
		}
		remote_paradigms = null;
	}

	public static void unsubscribeAll() {
		if (remote_paradigms==null) return;
		for(int i=0; i<remote_paradigms.length; i++) {
			if (remote_paradigms[i].subscribed) Main.backplane.unsubscribeParadigm(remote_paradigms[i].name, remote_paradigms[i].version);
		}		
	}
}