/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

// Subscribe_dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Generic_ToolAdaptor.h"
#include "Subscribe_dlg.h"

using namespace UdmCORBA;

extern map<long, PARADIGM_STRUCT> remote_paradigms;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Subscribe_dlg dialog


Subscribe_dlg::Subscribe_dlg(CWnd* pParent /*=NULL*/)
	: CDialog(Subscribe_dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(Subscribe_dlg)
	m_paradigm = -1;
	//}}AFX_DATA_INIT
}


void Subscribe_dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Subscribe_dlg)
	DDX_Control(pDX, IDC_PARADIGM, m_paradigm_control);
	DDX_CBIndex(pDX, IDC_PARADIGM, m_paradigm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Subscribe_dlg, CDialog)
	//{{AFX_MSG_MAP(Subscribe_dlg)
	ON_CBN_SELCHANGE(IDC_PARADIGM, OnSelchangeParadigm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Subscribe_dlg message handlers

BOOL Subscribe_dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	for(map<long, PARADIGM_STRUCT>::iterator i=remote_paradigms.begin(); i!=remote_paradigms.end(); i++) {
		CString item = (CString)(*i).second.name.c_str() + " v" + (CString)(*i).second.version.c_str();
		m_paradigm_control.AddString(item);
	}
	m_paradigm_control.SetCurSel(0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Subscribe_dlg::OnSelchangeParadigm() 
{
	// TODO: Add your control notification handler code here
	m_paradigm = m_paradigm_control.GetCurSel();
}
