// Update_Document_dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Generic_ToolAdaptor.h"
#include "Update_Document_dlg.h"

using namespace UdmCORBA;

extern list<CONFIG> config;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Update_Document_dlg dialog


Update_Document_dlg::Update_Document_dlg(CWnd* pParent /*=NULL*/)
	: CDialog(Update_Document_dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(Update_Document_dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void Update_Document_dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Update_Document_dlg)
	DDX_Control(pDX, IDC_DOCUMENT, m_existing_documents);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Update_Document_dlg, CDialog)
	//{{AFX_MSG_MAP(Update_Document_dlg)
	ON_CBN_SELCHANGE(IDC_DOCUMENT, OnSelchangeDocument)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Update_Document_dlg message handlers

extern vector<DOCUMENT_STRUCT> existing_documents;


bool __find_pstruct(list<PARADIGM_STRUCT> &lps1, list<PARADIGM_STRUCT> &lps2) {

	if (lps1.size() != lps2.size()) return false;

	for(list<PARADIGM_STRUCT>::iterator i=lps1.begin(); i!=lps1.end(); i++) {
		bool founded = false;
		for(list<PARADIGM_STRUCT>::iterator j=lps2.begin(); j!=lps2.end(); j++) {
			if (!(*i).name.compare((*j).name) && !(*i).version.compare((*j).version)) founded = true;
		}
		if (founded==false) return false;
	}

	return true;
}

BOOL Update_Document_dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_updated_document_id = -1;

	try {

		getDocumentsInfo();

		int offset = 0;
		bool corresponding_document = false;
		for(vector<DOCUMENT_STRUCT>::iterator i=existing_documents.begin(); i!=existing_documents.end(); i++) {
			list<PARADIGM_STRUCT> _document_paradigms = (*i).paradigms;

			bool founded = false;
			list<PARADIGM_STRUCT> __paradigms;
			for(list<CONFIG>::iterator qq=config.begin(); qq!=config.end(); qq++) {
				__paradigms = (*qq).paradigms;		
				if (__find_pstruct(__paradigms, _document_paradigms)) founded = true;
			}
			
			if (founded) {

				string temp_paradigms;
				for (list<PARADIGM_STRUCT>::iterator q=_document_paradigms.begin(); q!=_document_paradigms.end(); q++) {
					if (++q==_document_paradigms.end()) {
						--q;
						temp_paradigms += (*q).name + " v" + (*q).version;
					} else {
						--q;
						temp_paradigms += (*q).name + " v" + (*q).version + ",";
					}
				}	

				string temp = (*i).name + " v" + (*i).version + " (" + (*i).remarks + ")" + " (" + temp_paradigms + ")";
				m_existing_documents.InsertString(offset, temp.c_str());
				m_existing_documents.SetItemData(offset++, (*i).docID);
				corresponding_document = true;
			}
		}

		if (!corresponding_document) {
			MessageBox("There is no document in the Backplane server to be updated!", "Warning", MB_OK + MB_ICONINFORMATION);
			CDialog::OnCancel();
		}

		UpdateData(false);
		if (!existing_documents.empty()) {
			m_existing_documents.SetCurSel(0);
			m_updated_document_id = m_existing_documents.GetItemData(m_existing_documents.GetCurSel());
		}

	} catch (udmcorba_exception &e) {
		MessageBox(e.what(), "Error", MB_OK + MB_ICONEXCLAMATION);
		exit(-1);
	} catch (udm_exception &e) {
		MessageBox(e.what(), "Error", MB_OK + MB_ICONEXCLAMATION);
		exit(-1);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Update_Document_dlg::OnSelchangeDocument() 
{
	// TODO: Add your control notification handler code here
	m_updated_document_id = m_existing_documents.GetItemData(m_existing_documents.GetCurSel());
}
