// ta_types_dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Generic_ToolAdaptor.h"
#include "ta_types_dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ta_types_dlg dialog


ta_types_dlg::ta_types_dlg(CWnd* pParent /*=NULL*/)
	: CDialog(ta_types_dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ta_types_dlg)
	m_ta_type = _T("");
	//}}AFX_DATA_INIT
}


void ta_types_dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ta_types_dlg)
	DDX_Control(pDX, IDC_COMBO1, m_ta_types);
	DDX_CBString(pDX, IDC_COMBO1, m_ta_type);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ta_types_dlg, CDialog)
	//{{AFX_MSG_MAP(ta_types_dlg)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ta_types_dlg message handlers

BOOL ta_types_dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	try {
		list<string> ta_types;
		UdmCORBA::ToolAdaptor::getBackplaneToolAdaptorTypes(ta_types, __argc, __argv);

		if (ta_types.size()==0) {
			MessageBox("There is no ToolAdaptor types defined in the Backplane server. Generic ToolAdaptor could not run.", "Error", MB_OK + MB_ICONEXCLAMATION);
			exit(-1);
		}
		
		for(list<string>::iterator i=ta_types.begin(); i!=ta_types.end(); i++) m_ta_types.AddString((CString)(*i).c_str());

	} catch (udmcorba_exception &e) {
		MessageBox(e.what(), "Error", MB_OK + MB_ICONEXCLAMATION);
		exit(-1);
	} catch (udm_exception &e) {
		MessageBox(e.what(), "Error", MB_OK + MB_ICONEXCLAMATION);
		exit(-1);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void ta_types_dlg::OnSelchangeCombo1() 
{
	// TODO: Add your control notification handler code here
	m_ta_type = m_ta_types.GetCurSel();
}

void ta_types_dlg::OnOK() 
{
	// TODO: Add extra validation here
	if (!m_ta_type.IsEmpty()) CDialog::OnOK();
}
