// Fetch_A_Document.cpp : implementation file
//

#include "stdafx.h"
#include "Generic_ToolAdaptor_ActiveX.h"
#include "Fetch_A_Document.h"
#include "mgainterfaces.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "stdio.h"

extern CString xsl_file_for_fetch;

/////////////////////////////////////////////////////////////////////////////
// Fetch_A_Document dialog


Fetch_A_Document::Fetch_A_Document(CWnd* pParent /*=NULL*/)
	: CDialog(Fetch_A_Document::IDD, pParent)
{
	//{{AFX_DATA_INIT(Fetch_A_Document)
	m_working_dir = _T("");
	m_filename = _T("");
	m_file_extension = _T("");
	m_gme_paradigm = _T("");
	m_xslt_translation = FALSE;
	m_xslt_file = _T("");
	//}}AFX_DATA_INIT
}


void Fetch_A_Document::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Fetch_A_Document)
	DDX_Control(pDX, IDC_COMBO1, m_file_extensions);
	DDX_Control(pDX, IDC_LIST1, m_gme_paradigms);
	DDX_Text(pDX, IDC_EDIT1, m_working_dir);
	DDX_Text(pDX, IDC_EDIT2, m_filename);
	DDX_CBString(pDX, IDC_COMBO1, m_file_extension);
	DDX_LBString(pDX, IDC_LIST1, m_gme_paradigm);
	DDX_Check(pDX, IDC_CHECK1, m_xslt_translation);
	DDX_Text(pDX, IDC_EDIT3, m_xslt_file);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Fetch_A_Document, CDialog)
	//{{AFX_MSG_MAP(Fetch_A_Document)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_XSLT_SELECTION, OnXsltSelection)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



void LoadBstrSafeArray(CStringList& dest, SAFEARRAY* psa)
{
	ASSERT(psa);
	ASSERT(dest.IsEmpty());

	BSTR *p;
	SafeArrayAccessData(psa,(void**)&p);
	ASSERT(p);

	long bound;

	ASSERT( SafeArrayGetDim(psa) == 1 );
	SafeArrayGetLBound(psa, 1, &bound);
	ASSERT( bound == 1 );

	SafeArrayGetUBound(psa, 1, &bound);
	ASSERT( bound >= -1 );

	while( bound-- >= 1 )
		dest.AddTail(CString(*(p++)));

	SafeArrayUnaccessData(psa);
//	SafeArrayDestroy(psa);
//	psa = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// Fetch_A_Document message handlers

BOOL Fetch_A_Document::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CComPtr<IMgaRegistrar> registrar;
	::CoInitialize(NULL);
	registrar.CoCreateInstance(OLESTR("Mga.MgaRegistrar"));
	CComVariant vpars;
	registrar->get_Paradigms(REGACCESS_BOTH, &vpars);

	CStringList paradigms;
	ASSERT( ((vpars.vt & VT_ARRAY) == VT_ARRAY) || (vpars.vt == VT_EMPTY));
	LoadBstrSafeArray(paradigms, vpars.parray);

	POSITION pos = paradigms.GetHeadPosition();
	while (pos) {
		m_gme_paradigms.AddString(paradigms.GetNext(pos));
	}
	
	m_gme_paradigms.SetCurSel(0);
	m_file_extensions.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Fetch_A_Document::OnSelchangeCombo1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (!m_file_extension.Compare("mga"))
		m_gme_paradigms.EnableWindow(TRUE);
	else
		m_gme_paradigms.EnableWindow(FALSE);

	if (!m_file_extension.Compare("xml"))
		m_xslt_selection.EnableWindow(TRUE);
	else
		m_xslt_selection.EnableWindow(FALSE);

}

void Fetch_A_Document::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	CString file = m_working_dir + m_filename + "." + m_file_extension;
	FILE *f;		

	if ((f=fopen(file,"r"))!=NULL) {
		fclose(f);
		int result = MessageBox("The file exists! Do you want to overwrite it?", "Warning", MB_YESNO + MB_ICONQUESTION);
		if (result == IDNO) return;
	}
	
	CDialog::OnOK();
}

void Fetch_A_Document::OnXsltSelection() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CFileDialog open_dlg(TRUE, "xsl", "", OFN_NOCHANGEDIR);
	open_dlg.m_ofn.lpstrTitle = "Open the XSLT file for post-processing";
	int result = open_dlg.DoModal();
	if (result==IDOK) {

		if (open_dlg.GetFileExt().Compare("xsl")) {
			MessageBox("The file is not a xslt script file!", "Error", MB_OK + MB_ICONEXCLAMATION);
			return;
		}

		m_xslt_file = open_dlg.GetPathName();
		xsl_file_for_fetch = m_xslt_file;
	}

	UpdateData(FALSE);
}
