/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

// Manager.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Manager.h"
#include "ManagerDlg.h"
#include "ConnectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// *************************************************************************************************************************
// Global variables
// *************************************************************************************************************************
extern ManagerObject *manager;

/////////////////////////////////////////////////////////////////////////////
// CManagerApp

BEGIN_MESSAGE_MAP(CManagerApp, CWinApp)
	//{{AFX_MSG_MAP(CManagerApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManagerApp construction

CManagerApp::CManagerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CManagerApp object

CManagerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CManagerApp initialization

BOOL CManagerApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Connection Window
	CConnectionDlg conn_dlg;

	try {
		manager = new ManagerObject(Uml::diagram, "UML", "1.0", __argc, __argv);
	
		conn_dlg.m_strBackplaneName = manager->backplane_name().c_str();
		conn_dlg.m_strBackplaneVersion = manager->backplane_version().c_str();
		if (conn_dlg.DoModal() != IDOK) return false;

		manager->login(conn_dlg.m_strBackplanePassword);

	} catch (udmcorba_exception &e) {
		MessageBox(NULL, e.what(), "Error", MB_OK + MB_ICONEXCLAMATION);
		exit(-1);
	}

	// Main Window
	CManagerDlg dlg;
	dlg.m_strBackplanePassword = conn_dlg.m_strBackplanePassword;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
