


% Definition for the electronic throttle servo controller software.

clear Definition

% Input definitions.

Definition.Input = struct([]);


Definition.Input(1).Name = 'trig_etc_manager_fast';
Definition.Input(1).Description = 'trigger signal';
Definition.Input(1).Unit = 'none';
Definition.Input(1).FloatingPointTargetType = 'function call';
Definition.Input(1).FixedPointTargetType.Signed = [];
Definition.Input(1).FixedPointTargetType.Bytes = [];
Definition.Input(1).FixedPointTargetType.BinPoint = [];
Definition.Input(1).Size = [1 1];
Definition.Input(1).Min = [];
Definition.Input(1).Max = [];

Definition.Input(2).Name = 'trig_etc_servo_control_fast';
Definition.Input(2).Description = 'trigger signal';
Definition.Input(2).Unit = 'none';
Definition.Input(2).FloatingPointTargetType = 'function call';
Definition.Input(2).FixedPointTargetType.Signed = [];
Definition.Input(2).FixedPointTargetType.Bytes = [];
Definition.Input(2).FixedPointTargetType.BinPoint = [];
Definition.Input(2).Size = [1 1];
Definition.Input(2).Min = [];
Definition.Input(2).Max = [];

Definition.Input(3).Name = 'trig_etc_monitor_fast';
Definition.Input(3).Description = 'trigger signal';
Definition.Input(3).Unit = 'none';
Definition.Input(3).FloatingPointTargetType = 'function call';
Definition.Input(3).FixedPointTargetType.Signed = [];
Definition.Input(3).FixedPointTargetType.Bytes = [];
Definition.Input(3).FixedPointTargetType.BinPoint = [];
Definition.Input(3).Size = [1 1];
Definition.Input(3).Min = [];
Definition.Input(3).Max = [];

Definition.Input(4).Name = 'we';
Definition.Input(4).Description = 'measured engine speed';
Definition.Input(4).Unit = 'rad/s';
Definition.Input(4).FloatingPointTargetType = 'double';
Definition.Input(4).FixedPointTargetType.Signed = 0;
Definition.Input(4).FixedPointTargetType.Bytes = 2;
Definition.Input(4).FixedPointTargetType.BinPoint = 2;
Definition.Input(4).Size = [1 1];
Definition.Input(4).Min = 0;
Definition.Input(4).Max = 1048;

Definition.Input(5).Name = 'map';
Definition.Input(5).Description = 'manifold absolute pressure';
Definition.Input(5).Unit = 'kPa';
Definition.Input(5).FloatingPoinztTargetType = 'double';
Definition.Input(5).FixedPointTargetType.Signed = 0;
Definition.Input(5).FixedPointTargetType.Bytes = 2;
Definition.Input(5).FixedPointTargetType.BinPoint = 2;
Definition.Input(5).Size = [1 1];
Definition.Input(5).Min = 0;
Definition.Input(5).Max = 1.013e5;

Definition.Input(6).Name = 'tps1_volts';
Definition.Input(6).Description = 'throttle position sensor reading - sensor 1';
Definition.Input(6).Unit = 'volts';
Definition.Input(6).FloatingPointTargetType = 'double';
Definition.Input(6).FixedPointTargetType.Signed = 0;
Definition.Input(6).FixedPointTargetType.Bytes = 2;
Definition.Input(6).FixedPointTargetType.BinPoint = 2;
Definition.Input(6).Size = [1 1];
Definition.Input(6).Min = 5;
Definition.Input(6).Max = 12;

Definition.Input(7).Name = 'tps2_volts';
Definition.Input(7).Description = 'throttle position sensor reading - sensor 2';
Definition.Input(7).Unit = 'volts';
Definition.Input(7).FloatingPointTargetType = 'double';
Definition.Input(7).FixedPointTargetType.Signed = 0;
Definition.Input(7).FixedPointTargetType.Bytes = 2;
Definition.Input(7).FixedPointTargetType.BinPoint = 2;
Definition.Input(7).Size = [1 1];
Definition.Input(7).Min = 5;
Definition.Input(7).Max = 12;

Definition.Input(8).Name = 'o2s';
Definition.Input(8).Description = 'oxygen sensor';
Definition.Input(8).Unit = 'volts';
Definition.Input(8).FloatingPointTargetType = 'double';
Definition.Input(8).FixedPointTargetType.Signed = 0;
Definition.Input(8).FixedPointTargetType.Bytes = 2;
Definition.Input(8).FixedPointTargetType.BinPoint = 2;
Definition.Input(8).Size = [1 1];
Definition.Input(8).Min = 0;
Definition.Input(8).Max = 1.2;

Definition.Input(9).Name = 'alpha_cmd';
Definition.Input(9).Description = 'commanded throttle position from accelerator';
Definition.Input(9).Unit = 'radians';
Definition.Input(9).FloatingPointTargetType = 'double';
Definition.Input(9).FixedPointTargetType.Signed = 0;
Definition.Input(9).FixedPointTargetType.Bytes = 2;
Definition.Input(9).FixedPointTargetType.BinPoint = 2;
Definition.Input(9).Size = [1 1];
Definition.Input(9).Min = 0;
Definition.Input(9).Max = pi/2;

Definition.Input(10).Name = 'cruise_on';
Definition.Input(10).Description = 'cruise system master enable (1 = enabled, 0 = disabled)';
Definition.Input(10).Unit = 'enum'; 
Definition.Input(10).FloatingPointTargetType = 'boolean';
Definition.Input(10).FixedPointTargetType.Signed = 0;
Definition.Input(10).FixedPointTargetType.Bytes = 2;
Definition.Input(10).FixedPointTargetType.BinPoint = 2;
Definition.Input(10).Size = [1 1];
Definition.Input(10).Min = 0;
Definition.Input(10).Max = 1;

Definition.Input(11).Name = 'cruise_set';
Definition.Input(11).Description = 'cruise set switch (1 = engaged, 0 = disengaged)';
Definition.Input(11).Unit = 'enum'; 
Definition.Input(11).FloatingPointTargetType = 'boolean';
Definition.Input(11).FixedPointTargetType.Signed = 0;
Definition.Input(11).FixedPointTargetType.Bytes = 2;
Definition.Input(11).FixedPointTargetType.BinPoint = 2;
Definition.Input(11).Size = [1 1];
Definition.Input(11).Min = 0;
Definition.Input(11).Max = 1;

Definition.Input(12).Name = 'cruise_coast';
Definition.Input(12).Description = 'cruise coast switch (1 = engaged, 0 = disengaged)';
Definition.Input(12).Unit = 'enum'; 
Definition.Input(12).FloatingPointTargetType = 'boolean';
Definition.Input(12).FixedPointTargetType.Signed = 0;
Definition.Input(12).FixedPointTargetType.Bytes = 2;
Definition.Input(12).FixedPointTargetType.BinPoint = 2;
Definition.Input(12).Size = [1 1];
Definition.Input(12).Min = 0;
Definition.Input(12).Max = 1;

Definition.Input(13).Name = 'cruise_accel';
Definition.Input(13).Description = 'cruise accel switch (1 = engaged, 0 = disengaged)';
Definition.Input(13).Unit = 'enum'; 
Definition.Input(13).FloatingPointTargetType = 'boolean';
Definition.Input(13).FixedPointTargetType.Signed = 0;
Definition.Input(13).FixedPointTargetType.Bytes = 2;
Definition.Input(13).FixedPointTargetType.BinPoint = 2;
Definition.Input(13).Size = [1 1];
Definition.Input(13).Min = 0;
Definition.Input(13).Max = 1;

Definition.Input(14).Name = 'mfc';
Definition.Input(14).Description = 'unknown';
Definition.Input(14).Unit = 'unknown'; 
Definition.Input(14).FloatingPointTargetType = 'double';
Definition.Input(14).FixedPointTargetType.Signed = 0;
Definition.Input(14).FixedPointTargetType.Bytes = 2;
Definition.Input(14).FixedPointTargetType.BinPoint = 2;
Definition.Input(14).Size = [1 1];
Definition.Input(14).Min = 0;
Definition.Input(14).Max = 0;

Definition.Input(15).Name = 'ign_on_off';
Definition.Input(15).Unit = 'enum'; 
Definition.Input(15).FloatingPointTargetType = 'boolean';
Definition.Input(15).FixedPointTargetType.Signed = 0;
Definition.Input(15).FixedPointTargetType.Bytes = 2;
Definition.Input(15).FixedPointTargetType.BinPoint = 2;
Definition.Input(15).Size = [1 1];
Definition.Input(15).Min = 0;
Definition.Input(15).Max = 1;

Definition.Input(16).Name = 'wwf';
Definition.Input(16).Description = 'unknown';
Definition.Input(16).Unit = 'unknown'; 
Definition.Input(16).FloatingPointTargetType = 'double';
Definition.Input(16).FixedPointTargetType.Signed = 0;
Definition.Input(16).FixedPointTargetType.Bytes = 2;
Definition.Input(16).FixedPointTargetType.BinPoint = 2;
Definition.Input(16).Size = [1 1];
Definition.Input(16).Min = 0;
Definition.Input(16).Max = 0;

Definition.Input(17).Name = 'v';
Definition.Input(17).Description = 'measured vehicle velocity';
Definition.Input(17).Unit = 'm/s';
Definition.Input(17).FloatingPointTargetType = 'double';
Definition.Input(17).FixedPointTargetType.Signed = 0;
Definition.Input(17).FixedPointTargetType.Bytes = 2;
Definition.Input(17).FixedPointTargetType.BinPoint = 2;
Definition.Input(17).Size = [1 1];
Definition.Input(17).Min = -70;
Definition.Input(17).Max = 70;

Definition.Input(18).Name = 'map_max';
Definition.Input(18).Description = 'maximum available manifold absolute pressure';
Definition.Input(18).Unit = 'kPa';
Definition.Input(18).FloatingPoinztTargetType = 'double';
Definition.Input(18).FixedPointTargetType.Signed = 0;
Definition.Input(18).FixedPointTargetType.Bytes = 2;
Definition.Input(18).FixedPointTargetType.BinPoint = 2;
Definition.Input(18).Size = [1 1];
Definition.Input(18).Min = 0;
Definition.Input(18).Max = 1.013e5;

Definition.Input(19).Name = 'PRNDL';
Definition.Input(19).Description = 'measured shift selector position, -1 = reverse, 0 = neutral, 1 = first, 2 = second, 3 = third, 4 = fourth, 5 = fifth, 6 = sixth';
Definition.Input(19).Unit = 'enum'; 
Definition.Input(19).FloatingPointTargetType = 'int32';
Definition.Input(19).FixedPointTargetType.Signed = 0;
Definition.Input(19).FixedPointTargetType.Bytes = 2;
Definition.Input(19).FixedPointTargetType.BinPoint = 2;
Definition.Input(19).Size = [1 1];
Definition.Input(19).Min = -1;
Definition.Input(19).Max = 6;

Definition.Input(20).Name = 'brake_switch';
Definition.Input(20).Description = 'brake pedal switch (1 = depressed, 0 = not depressed)';
Definition.Input(20).Unit = 'enum'; 
Definition.Input(20).FloatingPointTargetType = 'boolean';
Definition.Input(20).FixedPointTargetType.Signed = 0;
Definition.Input(20).FixedPointTargetType.Bytes = 2;
Definition.Input(20).FixedPointTargetType.BinPoint = 2;
Definition.Input(20).Size = [1 1];
Definition.Input(20).Min = 0;
Definition.Input(20).Max = 1;

Definition.Input(21).Name = 'actual_current';
Definition.Input(21).Description = 'measured throttle motor current';
Definition.Input(21).Unit = 'amps';
Definition.Input(21).FloatingPointTargetType = 'double';
Definition.Input(21).FixedPointTargetType.Signed = 0;
Definition.Input(21).FixedPointTargetType.Bytes = 2;
Definition.Input(21).FixedPointTargetType.BinPoint = 2;
Definition.Input(21).Size = [1 1];
Definition.Input(21).Min = -24;
Definition.Input(21).Max = 24;

Definition.Input(22).Name = 'servo_task_cntr';
Definition.Input(22).Description = 'counter to monitor servo task ';
Definition.Input(22).Unit = 'none';
Definition.Input(22).FloatingPointTargetType = 'int32';
Definition.Input(22).FixedPointTargetType.Signed = 0;
Definition.Input(22).FixedPointTargetType.Bytes = 2;
Definition.Input(22).FixedPointTargetType.BinPoint = 2;
Definition.Input(22).Size = [1 1];
Definition.Input(22).Min = 0;
Definition.Input(22).Max = 65535;



% Output definitions.

Definition.Output = struct([]);

Definition.Output(1).Name = 'desired_current';
Definition.Output(1).Description = 'desired throttle motor current';
Definition.Output(1).Unit = 'amps';
Definition.Output(1).FloatingPointTargetType = 'double';
Definition.Output(1).FixedPointTargetType.Signed = 0;
Definition.Output(1).FixedPointTargetType.Bytes = 2;
Definition.Output(1).FixedPointTargetType.BinPoint = 2;
Definition.Output(1).Size = [1 1];
Definition.Output(1).Min = -24;
Definition.Output(1).Max = 24;

% Parameter definitions.

Definition.Parameter = struct([]);

Definition.Parameter(1).Name = 'etc_software_controller_cpu_usage_max';
Definition.Parameter(1).Description = 'percentage of CPU troughput to be alloacted to etc_controller_software';
Definition.Parameter(1).Unit = '';
Definition.Parameter(1).FloatingPointTargetType = 'double';
Definition.Parameter(1).FixedPointTargetType.Signed = 0;
Definition.Parameter(1).FixedPointTargetType.Bytes = 2;
Definition.Parameter(1).FixedPointTargetType.BinPoint = 10;
Definition.Parameter(1).Size = [1 1];
Definition.Parameter(1).Min = 0;
Definition.Parameter(1).Max = 100;
Definition.Parameter(1).DefaultValue = 20;

Definition.Parameter(2).Name = 'etc_software_controller_ROM_max';
Definition.Parameter(2).Description = 'bytes of ROM to be alloacted to etc_controller_software';
Definition.Parameter(2).Unit = '';
Definition.Parameter(2).FloatingPointTargetType = 'double';
Definition.Parameter(2).FixedPointTargetType.Signed = 0;
Definition.Parameter(2).FixedPointTargetType.Bytes = 2;
Definition.Parameter(2).FixedPointTargetType.BinPoint = 10;
Definition.Parameter(2).Size = [1 1];
Definition.Parameter(2).Min = 0;
Definition.Parameter(2).Max = 1000000;
Definition.Parameter(2).DefaultValue = 200000;

Definition.Parameter(3).Name = 'etc_software_controller_RAM_max';
Definition.Parameter(3).Description = 'bytes of RAM to be alloacted to etc_controller_software, includes stack';
Definition.Parameter(3).Unit = '';
Definition.Parameter(3).FloatingPointTargetType = 'double';
Definition.Parameter(3).FixedPointTargetType.Signed = 0;
Definition.Parameter(3).FixedPointTargetType.Bytes = 2;
Definition.Parameter(3).FixedPointTargetType.BinPoint = 10;
Definition.Parameter(3).Size = [1 1];
Definition.Parameter(3).Min = 0;
Definition.Parameter(3).Max = 32000;
Definition.Parameter(3).DefaultValue = 5000;
