% Definition for the electronic throttle control manager.

clear Definition

% Input definitions.

Definition.Input = struct([]);

Definition.Input(1).Name = 'trig_etc_manager_fast';
Definition.Input(1).Description = 'trigger signal';
Definition.Input(1).Unit = 'none';
Definition.Input(1).FloatingPointTargetType = 'function call';
Definition.Input(1).FixedPointTargetType.Signed = [];
Definition.Input(1).FixedPointTargetType.Bytes = [];
Definition.Input(1).FixedPointTargetType.BinPoint = [];
Definition.Input(1).Size = [1 1];
Definition.Input(1).Min = [];
Definition.Input(1).Max = [];

Definition.Input(2).Name = 'we';
Definition.Input(2).Description = 'measured engine speed';
Definition.Input(2).Unit = 'rad/s';
Definition.Input(2).FloatingPointTargetType = 'double';
Definition.Input(2).FixedPointTargetType.Signed = 0;
Definition.Input(2).FixedPointTargetType.Bytes = 2;
Definition.Input(2).FixedPointTargetType.BinPoint = 2;
Definition.Input(2).Size = [1 1];
Definition.Input(2).Min = 0;
Definition.Input(2).Max = 1048;

Definition.Input(3).Name = 'map';
Definition.Input(3).Description = 'manifold absolute pressure';
Definition.Input(3).Unit = 'kPa';
Definition.Input(3).FloatingPoinztTargetType = 'double';
Definition.Input(3).FixedPointTargetType.Signed = 0;
Definition.Input(3).FixedPointTargetType.Bytes = 2;
Definition.Input(3).FixedPointTargetType.BinPoint = 2;
Definition.Input(3).Size = [1 1];
Definition.Input(3).Min = 0;
Definition.Input(3).Max = 1.013e5;

Definition.Input(4).Name = 'tps1_volts';
Definition.Input(4).Description = 'throttle position sensor reading - sensor 1';
Definition.Input(4).Unit = 'volts';
Definition.Input(4).FloatingPointTargetType = 'double';
Definition.Input(4).FixedPointTargetType.Signed = 0;
Definition.Input(4).FixedPointTargetType.Bytes = 2;
Definition.Input(4).FixedPointTargetType.BinPoint = 2;
Definition.Input(4).Size = [1 1];
Definition.Input(4).Min = 5;
Definition.Input(4).Max = 12;

Definition.Input(5).Name = 'tps2_volts';
Definition.Input(5).Description = 'throttle position sensor reading - sensor 2';
Definition.Input(5).Unit = 'volts';
Definition.Input(5).FloatingPointTargetType = 'double';
Definition.Input(5).FixedPointTargetType.Signed = 0;
Definition.Input(5).FixedPointTargetType.Bytes = 2;
Definition.Input(5).FixedPointTargetType.BinPoint = 2;
Definition.Input(5).Size = [1 1];
Definition.Input(5).Min = 5;
Definition.Input(5).Max = 12;

Definition.Input(6).Name = 'o2s';
Definition.Input(6).Description = 'oxygen sensor';
Definition.Input(6).Unit = 'volts';
Definition.Input(6).FloatingPointTargetType = 'double';
Definition.Input(6).FixedPointTargetType.Signed = 0;
Definition.Input(6).FixedPointTargetType.Bytes = 2;
Definition.Input(6).FixedPointTargetType.BinPoint = 2;
Definition.Input(6).Size = [1 1];
Definition.Input(6).Min = 0;
Definition.Input(6).Max = 1.2;

Definition.Input(7).Name = 'alpha_cmd';
Definition.Input(7).Description = 'commanded throttle position from accelerator';
Definition.Input(7).Unit = 'radians';
Definition.Input(7).FloatingPointTargetType = 'double';
Definition.Input(7).FixedPointTargetType.Signed = 0;
Definition.Input(7).FixedPointTargetType.Bytes = 2;
Definition.Input(7).FixedPointTargetType.BinPoint = 2;
Definition.Input(7).Size = [1 1];
Definition.Input(7).Min = 0;
Definition.Input(7).Max = pi/2;

Definition.Input(8).Name = 'cruise_on';
Definition.Input(8).Description = 'cruise system master enable (1 = enabled, 0 = disabled)';
Definition.Input(8).Unit = 'enum'; 
Definition.Input(8).FloatingPointTargetType = 'boolean';
Definition.Input(8).FixedPointTargetType.Signed = 0;
Definition.Input(8).FixedPointTargetType.Bytes = 2;
Definition.Input(8).FixedPointTargetType.BinPoint = 2;
Definition.Input(8).Size = [1 1];
Definition.Input(8).Min = 0;
Definition.Input(8).Max = 1;

Definition.Input(9).Name = 'cruise_set';
Definition.Input(9).Description = 'cruise set switch (1 = engaged, 0 = disengaged)';
Definition.Input(9).Unit = 'enum'; 
Definition.Input(9).FloatingPointTargetType = 'boolean';
Definition.Input(9).FixedPointTargetType.Signed = 0;
Definition.Input(9).FixedPointTargetType.Bytes = 2;
Definition.Input(9).FixedPointTargetType.BinPoint = 2;
Definition.Input(9).Size = [1 1];
Definition.Input(9).Min = 0;
Definition.Input(9).Max = 1;

Definition.Input(10).Name = 'cruise_coast';
Definition.Input(10).Description = 'cruise coast switch (1 = engaged, 0 = disengaged)';
Definition.Input(10).Unit = 'enum'; 
Definition.Input(10).FloatingPointTargetType = 'boolean';
Definition.Input(10).FixedPointTargetType.Signed = 0;
Definition.Input(10).FixedPointTargetType.Bytes = 2;
Definition.Input(10).FixedPointTargetType.BinPoint = 2;
Definition.Input(10).Size = [1 1];
Definition.Input(10).Min = 0;
Definition.Input(10).Max = 1;

Definition.Input(11).Name = 'cruise_accel';
Definition.Input(11).Description = 'cruise accel switch (1 = engaged, 0 = disengaged)';
Definition.Input(11).Unit = 'enum'; 
Definition.Input(11).FloatingPointTargetType = 'boolean';
Definition.Input(11).FixedPointTargetType.Signed = 0;
Definition.Input(11).FixedPointTargetType.Bytes = 2;
Definition.Input(11).FixedPointTargetType.BinPoint = 2;
Definition.Input(11).Size = [1 1];
Definition.Input(11).Min = 0;
Definition.Input(11).Max = 1;

Definition.Input(12).Name = 'mfc';
Definition.Input(12).Description = 'unknown';
Definition.Input(12).Unit = 'unknown'; 
Definition.Input(12).FloatingPointTargetType = 'double';
Definition.Input(12).FixedPointTargetType.Signed = 0;
Definition.Input(12).FixedPointTargetType.Bytes = 2;
Definition.Input(12).FixedPointTargetType.BinPoint = 2;
Definition.Input(12).Size = [1 1];
Definition.Input(12).Min = 0;
Definition.Input(12).Max = 0;

Definition.Input(13).Name = 'ign_on_off';
Definition.Input(13).Description = 'Ignition switch (1 = on, 0 = off)';
Definition.Input(13).Unit = 'enum'; 
Definition.Input(13).FloatingPointTargetType = 'boolean';
Definition.Input(13).FixedPointTargetType.Signed = 0;
Definition.Input(13).FixedPointTargetType.Bytes = 2;
Definition.Input(13).FixedPointTargetType.BinPoint = 2;
Definition.Input(13).Size = [1 1];
Definition.Input(13).Min = 0;
Definition.Input(13).Max = 1;

Definition.Input(14).Name = 'wwf';
Definition.Input(14).Description = 'unknown';
Definition.Input(14).Unit = 'unknown'; 
Definition.Input(14).FloatingPointTargetType = 'double';
Definition.Input(14).FixedPointTargetType.Signed = 0;
Definition.Input(14).FixedPointTargetType.Bytes = 2;
Definition.Input(14).FixedPointTargetType.BinPoint = 2;
Definition.Input(14).Size = [1 1];
Definition.Input(14).Min = 0;
Definition.Input(14).Max = 0;

Definition.Input(15).Name = 'v';
Definition.Input(15).Description = 'measured vehicle velocity';
Definition.Input(15).Unit = 'm/s';
Definition.Input(15).FloatingPointTargetType = 'double';
Definition.Input(15).FixedPointTargetType.Signed = 0;
Definition.Input(15).FixedPointTargetType.Bytes = 2;
Definition.Input(15).FixedPointTargetType.BinPoint = 2;
Definition.Input(15).Size = [1 1];
Definition.Input(15).Min = -70;
Definition.Input(15).Max = 70;

Definition.Input(16).Name = 'map_max';
Definition.Input(16).Description = 'maximum available manifold absolute pressure';
Definition.Input(16).Unit = 'kPa';
Definition.Input(16).FloatingPoinztTargetType = 'double';
Definition.Input(16).FixedPointTargetType.Signed = 0;
Definition.Input(16).FixedPointTargetType.Bytes = 2;
Definition.Input(16).FixedPointTargetType.BinPoint = 2;
Definition.Input(16).Size = [1 1];
Definition.Input(16).Min = 0;
Definition.Input(16).Max = 1.013e5;

Definition.Input(17).Name = 'PRNDL';
Definition.Input(17).Description = 'measured shift selector position, -1 = reverse, 0 = neutral, 1 = first, 2 = second, 3 = third, 4 = fourth, 5 = fifth, 6 = sixth';
Definition.Input(17).Unit = 'enum'; 
Definition.Input(17).FloatingPointTargetType = 'int32';
Definition.Input(17).FixedPointTargetType.Signed = 0;
Definition.Input(17).FixedPointTargetType.Bytes = 2;
Definition.Input(17).FixedPointTargetType.BinPoint = 2;
Definition.Input(17).Size = [1 1];
Definition.Input(17).Min = -1;
Definition.Input(17).Max = 6;

Definition.Input(18).Name = 'brake_switch';
Definition.Input(18).Description = 'brake pedal switch (1 = depressed, 0 = not depressed)';
Definition.Input(18).Unit = 'enum'; 
Definition.Input(18).FloatingPointTargetType = 'boolean';
Definition.Input(18).FixedPointTargetType.Signed = 0;
Definition.Input(18).FixedPointTargetType.Bytes = 2;
Definition.Input(18).FixedPointTargetType.BinPoint = 2;
Definition.Input(18).Size = [1 1];
Definition.Input(18).Min = 0;
Definition.Input(18).Max = 1;

Definition.Input(19).Name = 'which_faults';
Definition.Input(19).Description = 'fault conditions (FaultNoFault = 0, FaultHardwareTPS = 1, FaultHardwareActuator  = 2, FaultSoftwareManagerTask = 4)';
Definition.Input(19).Unit = 'enum'; 
Definition.Input(19).FloatingPointTargetType = 'int32';
Definition.Input(19).FixedPointTargetType.Signed = 0;
Definition.Input(19).FixedPointTargetType.Bytes = 2;
Definition.Input(19).FixedPointTargetType.BinPoint = 2;
Definition.Input(19).Size = [1 1];
Definition.Input(19).Min = 0;
Definition.Input(19).Max = 7;


% Output definitions.

Definition.Output = struct([]);

Definition.Output = struct([]);

Definition.Output(1).Name = 'which_mode';
Definition.Output(1).Description = 'throttle control modes: 1 = SelectStartup, 2  = SelectDriving, 3 = SelectLimiting, 4 = SelectLimpHome, or 5 = SelectShutdown';
Definition.Output(1).Unit = 'enum';
Definition.Output(1).FloatingPointTargetType = 'int32';
Definition.Output(1).FixedPointTargetType.Signed = 0;
Definition.Output(1).FixedPointTargetType.Bytes = 2;
Definition.Output(1).FixedPointTargetType.BinPoint = 2;
Definition.Output(1).Size = [1 1];
Definition.Output(1).Min = 1;
Definition.Output(1).Max = 5;

Definition.Output(2).Name = 'which_driving_cruise';
Definition.Output(2).Description = 'cruise control modes: 2 = SelectDrivingCruiseMin (inactive)f, or 1 = SelectDrivingCruise';
Definition.Output(2).Unit = 'enum';
Definition.Output(2).FloatingPointTargetType = 'int32';
Definition.Output(2).FixedPointTargetType.Signed = 0;
Definition.Output(2).FixedPointTargetType.Bytes = 2;
Definition.Output(2).FixedPointTargetType.BinPoint = 2;
Definition.Output(2).Size = [1 1];
Definition.Output(2).Min = 1;
Definition.Output(2).Max = 2;

Definition.Output(3).Name = 'which_limiting_rev';
Definition.Output(3).Description = 'engine speed limiting modes: 2 = SelectLimitingRevMax (inactive), or 1 = SelectLimitingRev';
Definition.Output(3).Unit = 'enum';
Definition.Output(3).FloatingPointTargetType = 'int32';
Definition.Output(3).FixedPointTargetType.Signed = 0;
Definition.Output(3).FixedPointTargetType.Bytes = 2;
Definition.Output(3).FixedPointTargetType.BinPoint = 2;
Definition.Output(3).Size = [1 1];
Definition.Output(3).Min = 1;
Definition.Output(3).Max = 2;

Definition.Output(4).Name = 'which_limiting_traction';
Definition.Output(4).Description = 'traction control limiting modes: 2 = SelectLimitingTractionMax (inactive), or 1 = SelectLimitingTraction';
Definition.Output(4).Unit = 'enum';
Definition.Output(4).FloatingPointTargetType = 'int32';
Definition.Output(4).FixedPointTargetType.Signed = 0;
Definition.Output(4).FixedPointTargetType.Bytes = 2;
Definition.Output(4).FixedPointTargetType.BinPoint = 2;
Definition.Output(4).Size = [1 1];
Definition.Output(4).Min = 1;
Definition.Output(4).Max = 2;

Definition.Output(5).Name = 'task_manager_cntr';
Definition.Output(5).Description = 'counter to indicate the manager task is running, incremented once per etc_manager_fast_mode_switch execution';
Definition.Output(5).Unit = 'none';
Definition.Output(5).FloatingPointTargetType = 'int32';
Definition.Output(5).FixedPointTargetType.Signed = 0;
Definition.Output(5).FixedPointTargetType.Bytes = 2;
Definition.Output(5).FixedPointTargetType.BinPoint = 2;
Definition.Output(5).Size = [1 1];
Definition.Output(5).Min = 0;
Definition.Output(5).Max = 1000;

% Parameter definitions.


Definition.Parameter = struct([]);

Definition.Parameter(1).Name = 'etc_manager2_cpu_usage';
Definition.Parameter(1).Description = 'percentage of CPU troughput used by etc_manager2';
Definition.Parameter(1).Unit = '';
Definition.Parameter(1).FloatingPointTargetType = 'double';
Definition.Parameter(1).FixedPointTargetType.Signed = 0;
Definition.Parameter(1).FixedPointTargetType.Bytes = 2;
Definition.Parameter(1).FixedPointTargetType.BinPoint = 10;
Definition.Parameter(1).Size = [1 1];
Definition.Parameter(1).Min = 0;
Definition.Parameter(1).Max = 100;
Definition.Parameter(1).DefaultValue = 1;

Definition.Parameter(2).Name = 'etc_manager2_ROM';
Definition.Parameter(2).Description = 'bytes of ROM used by etc_manager2';
Definition.Parameter(2).Unit = '';
Definition.Parameter(2).FloatingPointTargetType = 'double';
Definition.Parameter(2).FixedPointTargetType.Signed = 0;
Definition.Parameter(2).FixedPointTargetType.Bytes = 2;
Definition.Parameter(2).FixedPointTargetType.BinPoint = 10;
Definition.Parameter(2).Size = [1 1];
Definition.Parameter(2).Min = 0;
Definition.Parameter(2).Max = 1000000;
Definition.Parameter(2).DefaultValue = 150000;

Definition.Parameter(3).Name = 'etc_manager2_RAM';
Definition.Parameter(3).Description = 'bytes of RAM used by etc_manager2, includes stack';
Definition.Parameter(3).Unit = '';
Definition.Parameter(3).FloatingPointTargetType = 'double';
Definition.Parameter(3).FixedPointTargetType.Signed = 0;
Definition.Parameter(3).FixedPointTargetType.Bytes = 2;
Definition.Parameter(3).FixedPointTargetType.BinPoint = 10;
Definition.Parameter(3).Size = [1 1];
Definition.Parameter(3).Min = 0;
Definition.Parameter(3).Max = 32000;
Definition.Parameter(3).DefaultValue = 300;
