// ToolAdaptor.cpp : Defines the class behaviors for the application.
//
#pragma warning( disable : 4666 )

#include "stdafx.h"

#include "ToolAdaptor.h"
#include "TA_MFC_Support.h"

#include "test.h"
#include "UdmDom.h"
#include "UdmCORBA.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CToolAdaptorApp

BEGIN_MESSAGE_MAP(CToolAdaptorApp, CWinApp)
	//{{AFX_MSG_MAP(CToolAdaptorApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolAdaptorApp construction

CToolAdaptorApp::CToolAdaptorApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// *************************************************************************************************************************
// myToolAdaptor
// *************************************************************************************************************************
class myToolAdaptor : public UdmCORBA::ToolAdaptor {

public:
	myToolAdaptor(const char *type, int argc, char **argv) 
		: ToolAdaptor(type, argc, argv) {};

	void notify(const char *par_name, const char *par_version, const char *name, const char *version, const char *remarks, long docId, long keepAlive) {

		try {
			CString filename;
			
			while (filename.GetLength()<5 || filename.Right(4)!=".xml") {
				int result = showDatanetworkArrivedDlg(name, version, remarks, keepAlive, &filename, "xml");
				if (result==IDCANCEL) return;
				if (filename.GetLength()<5 || filename.Right(4)!=".xml") 
					MessageBox(NULL, "Invalid filename! Filename must end with .xml", "Error", MB_OK);
			}
		
			dn->CreateNew((LPCTSTR)filename, "test", test::Root::meta, Udm::CHANGES_PERSIST_ALWAYS);
			dn->fetchDocument(docId);
			addStringFetchDlg("Datanetwork fetched.");

			dn->SaveAs((LPCSTR)filename);
			addStringFetchDlg("Datanetwork saved as " + filename);

			dn->CloseNoUpdate();
			dn->release();

			addStringFetchDlg("");
			addStringFetchDlg("Waiting for Datanetworks...");

		} catch (udm_exception &e) {
			addStringFetchDlg(e.what());
		} catch (udmcorba_exception &e) {
			addStringFetchDlg(e.what());
		} catch (...) {
			addStringFetchDlg("Fatal Error!");
			return;
		}

	};
};

myToolAdaptor *ta;

// *************************************************************************************************************************
// working Thread
// *************************************************************************************************************************
CWinThread *working_thread;

UINT MyWorkingThread( LPVOID pParam ) {

	try {
		myToolAdaptor *ta = new myToolAdaptor("TEST_RECEIVER", __argc, __argv);

		addStringFetchDlg("Subscribe to TEST paradigm v1.0");
		ta->subscribe(test::diagram, "TEST", "1.0");
		addStringFetchDlg("Waiting for Datanetworks...");
		ta->run();

		ta->logout();
		delete ta;
		
	} catch (udm_exception &e) {
		MessageBox(NULL, e.what(), "Error!", MB_OK);
		return -1;
	} catch (udmcorba_exception &e) {
		MessageBox(NULL, e.what(), "Error", MB_OK);
		return -1;
	}

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// The one and only CToolAdaptorApp object

CToolAdaptorApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CToolAdaptorApp initialization

BOOL CToolAdaptorApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	try {
	
		// publish Document
		CString name, version, remarks, filename;
		long keepAlive;

		int result = showPublishDlg(&name, &version, &remarks, &keepAlive, &filename);

		if (result==IDOK) {
			ta = new myToolAdaptor("TEST_PUBLISHER", __argc, __argv);

			UdmCORBA::CORBADataNetwork *dn = ta->getDatanetwork(test::diagram, "TEST", "1.0");

			try {
				dn->OpenExisting((LPCSTR)filename, "test", Udm::CHANGES_LOST_DEFAULT);
			} catch (udm_exception &e) {
				string error = e.what();
				if (!error.compare("Not found")) MessageBox(NULL, "Invalid input file!", "Error", MB_OK);
				else MessageBox(NULL, e.what(), "Error", MB_OK);
				return false;
			}

			dn->publishDocument((LPCSTR)name, (LPCSTR)version, (LPCSTR)remarks, keepAlive);
			
			ta->logout();
		}

		// fetch Document
		working_thread = AfxBeginThread(MyWorkingThread, NULL);
		showFetchDlg("ToolAdaptor TEST");

	} catch (udm_exception &e) {
		MessageBox(NULL, e.what(), "Error", MB_OK);
	} catch (udmcorba_exception &e) {
		MessageBox(NULL, e.what(), "Error", MB_OK);
	}

	
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
