// DB2DSME.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#pragma warning(disable:4666)

#include "TA_MFC_Support.h"
#include "UdmCORBA.h"

#include "DB2DSME.h"
#include "DB2DSMEDlg.h"

#include "DSME.h"
#include "DesertIfaceBack.h"
#include "UdmDom.h"
#include "UdmGme.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CDB2DSMEApp

BEGIN_MESSAGE_MAP(CDB2DSMEApp, CWinApp)
	//{{AFX_MSG_MAP(CDB2DSMEApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDB2DSMEApp construction

CDB2DSMEApp::CDB2DSMEApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


string document_name;
string document_version;
long document_keepAlive;
UdmCORBA::CORBADataNetwork *dn_back;

// *************************************************************************************************************************
// myToolAdaptor
// *************************************************************************************************************************
class myToolAdaptor : public UdmCORBA::ToolAdaptor {

public:
	myToolAdaptor(const char *type, int argc, char **argv) 
		: ToolAdaptor(type, argc, argv) {};

	void notify(const char *par_name, const char *par_version, const char *name, const char *version, const char *remarks, long docId, long keepAlive) {

		try {
			document_name = name;
			document_version = version;
			document_keepAlive = keepAlive;

			dn_back = getDatanetwork(DesertIfaceBack::diagram, "DESERTBACK", "1.0");
			dn_back->CreateNew("__temp_desertback_1.0.xml", "DesertIfaceBack", DesertIfaceBack::DesertBackSystem::meta, Udm::CHANGES_LOST_DEFAULT);
			dn_back->fetchDocument(docId);

			UdmCORBA::CORBADataNetwork *dn_dsme = getDatanetwork(DSME::diagram, "DSME", "1.0");
			dn_dsme->CreateNew("__temp_dsme_1.0.mem", "DSME", DSME::RootFolder::meta, Udm::CHANGES_LOST_DEFAULT);
			dn_dsme->fetchDocument(docId);

			addStringFetchDlg("Document is arrived and opened in the DB2DSME Tool.");

//			UdmDom::DomDataNetwork db(DesertIfaceBack::diagram);
//			UdmGme::GmeDataNetwork dsme(DSME::diagram);

			// read-in the db & dsme file 
//			db.OpenExisting(db_file, "", Udm::CHANGES_LOST_DEFAULT);
//			dsme.OpenExisting(dsme_file, "", Udm::CHANGES_LOST_DEFAULT);

			DesertIfaceBack::DesertBackSystem db_root = DesertIfaceBack::DesertBackSystem::Cast(dn_back->GetRootObject());
			DSME::RootFolder dsme_root = DSME::RootFolder::Cast(dn_dsme->GetRootObject());

			set<DesertIfaceBack::Configuration> configurations = db_root.configurations();

			CDB2DSMEDlg dlg(dsme_root, configurations);
//			m_pMainWnd = &dlg;
			int nResponse = dlg.DoModal();

			configurations.clear();

			dn_dsme->CloseNoUpdate();
			dn_dsme->release();

			dn_back->CloseNoUpdate();
			dn_back->release();

		} catch (udm_exception &e) {
			addStringFetchDlg(e.what());
			AfxMessageBox(CString("UDM Exception: ") + CString(e.what()));
		} catch (udmcorba_exception &e) {
			addStringFetchDlg(e.what());
		} catch (...) {
			addStringFetchDlg("Fatal Error!");
		}

	};
};

myToolAdaptor *ta;


// *************************************************************************************************************************
// working Thread
// *************************************************************************************************************************
CWinThread *working_thread;

UINT MyWorkingThread( LPVOID pParam ) {

	try {
		myToolAdaptor *ta = new myToolAdaptor("DB2DSME_TOOL", __argc, __argv);

		addStringFetchDlg("Subscribe to DESERTBACK paradigm v1.0");
		ta->subscribe(DesertIfaceBack::diagram, "DESERTBACK", "1.0");
		addStringFetchDlg("Waiting for Datanetworks...");
		ta->run();

		ta->logout();
		delete ta;

	} catch (udm_exception &e) {
		MessageBox(NULL, e.what(), "Error!", MB_OK);
		return -1;
	} catch (udmcorba_exception &e) {
		MessageBox(NULL, e.what(), "Error", MB_OK);
		return -1;
	}

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// The one and only CDB2DSMEApp object

CDB2DSMEApp theApp;
char db_file[_MAX_PATH];
char dsme_file[_MAX_PATH];


/////////////////////////////////////////////////////////////////////////////
// CDB2DSMEApp initialization

BOOL CDB2DSMEApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

/*
	if (!m_lpCmdLine || (sscanf(m_lpCmdLine, "%s %s", db_file, dsme_file) < 2))
	{
		AfxMessageBox(CString("Insufficient arguments!\nUsage: ") + CString(this->m_pszAppName)
			+ CString(" <desert_back_file.xml> <dsme_file.mga>"));
		return FALSE;
	}
*/

	try {

		// fetch Document
		working_thread = AfxBeginThread(MyWorkingThread, NULL);
		showFetchDlg("DB2DSME Tool");

	} catch (udm_exception &e) {
		MessageBox(NULL, e.what(), "Error", MB_OK);
	} catch (udmcorba_exception &e) {
		MessageBox(NULL, e.what(), "Error", MB_OK);
	}


/*
	try {
		UdmDom::DomDataNetwork db(DesertIfaceBack::diagram);
		UdmGme::GmeDataNetwork dsme(DSME::diagram);

		// read-in the db & dsme file 
		db.OpenExisting(db_file, "", Udm::CHANGES_LOST_DEFAULT);
		dsme.OpenExisting(dsme_file, "", Udm::CHANGES_LOST_DEFAULT);

		DesertIfaceBack::DesertBackSystem db_root = DesertIfaceBack::DesertBackSystem::Cast(db.GetRootObject());
		DSME::RootFolder dsme_root = DSME::RootFolder::Cast(dsme.GetRootObject());

		set<DesertIfaceBack::Configuration> configurations = db_root.configurations();

		CDB2DSMEDlg dlg(dsme_root, configurations);
		m_pMainWnd = &dlg;
		int nResponse = dlg.DoModal();

		configurations.clear();
		db.CloseNoUpdate();
		dsme.CloseNoUpdate();
	} catch (udm_exception e) {

		AfxMessageBox(CString("UDM Exception: ") + CString(e.what()));
	}
*/

	return FALSE;
}
