// DB2DSMEDlg.cpp : implementation file
//

#include "stdafx.h"

#pragma warning(disable:4666)
#pragma warning(disable:4244)

#include "UdmCORBA.h"

#include "DB2DSME.h"
#include "DB2DSMEDlg.h"
#include "Uml.h"
#include "UdmGme.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern string document_name;
extern string document_version;
extern long document_keepAlive;
extern UdmCORBA::CORBADataNetwork *dn_back;

class myToolAdaptor : public UdmCORBA::ToolAdaptor {

public:
	myToolAdaptor(const char *type, int argc, char **argv) 
		: ToolAdaptor(type, argc, argv) {};

	void notify(const char *par_name, const char *par_version, const char *name, const char *version, const char *remarks, long docId, long keepAlive) {};

	void getPublishStatus(long percent) {}
};

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDB2DSMEDlg dialog

CDB2DSMEDlg::CDB2DSMEDlg(DSME::RootFolder& d_root, set<DesertIfaceBack::Configuration>& d_cfgs, CWnd* pParent /*=NULL*/)
	: CDialog(CDB2DSMEDlg::IDD, pParent), in_root(d_root), in_configs(d_cfgs)
{
	//{{AFX_DATA_INIT(CDB2DSMEDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	num_configs = in_configs.size();
}

void CDB2DSMEDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDB2DSMEDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDB2DSMEDlg, CDialog)
	//{{AFX_MSG_MAP(CDB2DSMEDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(UDN_DELTAPOS, IDC_CONFIG_SPIN, OnDeltaposConfigSpin)
	ON_BN_CLICKED(IDC_GENERATE, OnGenerate)
	ON_BN_CLICKED(IDC_VIEW, OnView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDB2DSMEDlg message handlers

extern char db_file[_MAX_PATH];
extern char dsme_file[_MAX_PATH];

BOOL CDB2DSMEDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CEdit *cfg_box = (CEdit *)GetDlgItem(IDC_CONFIG_NUM);
	cfg_box->SetWindowText("0");
	CSpinButtonCtrl *spn = (CSpinButtonCtrl *)GetDlgItem(IDC_CONFIG_SPIN);
	spn->SetRange(0, num_configs);
	spn->SetPos(0);

	CStatic *st = (CStatic *)GetDlgItem(IDC_STATIC);
	CString buf; buf.Format("Displaying Configuration 0 of %d", num_configs);
	st->SetWindowText( buf );

	map<int, int> alt_assignment;
	MapConfiguration(0, alt_assignment);
	FillConfigTree((CTreeCtrl *)GetDlgItem(IDC_CONFIG_TREE), alt_assignment);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDB2DSMEDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDB2DSMEDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDB2DSMEDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDB2DSMEDlg::OnDeltaposConfigSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	CEdit* edt = (CEdit *)GetDlgItem(IDC_CONFIG_NUM);
	CString str; 

	edt->GetWindowText(str);
	int config_id = atoi(str) + pNMUpDown->iDelta;

	if (config_id < 0 || config_id >= num_configs)
	{
		*pResult = 1;
	} else {
		str.Format("%d", config_id);
		edt->SetWindowText(str);
		*pResult = 0;
	}
	
	*pResult = 0;
}

void CDB2DSMEDlg::OnGenerate() 
{
	CEdit* edt = (CEdit *)GetDlgItem(IDC_CONFIG_NUM);
	CString str; 

	edt->GetWindowText(str);
	int config_id = atoi(str);
	if (config_id < 0 || config_id >= num_configs) return;

	map<int, int> alt_assignment;
	MapConfiguration(config_id, alt_assignment);
	GenerateConfig(config_id, alt_assignment);

	CStatic *st = (CStatic *)GetDlgItem(IDC_STATIC);
	CString buf; buf.Format("Generated Configuration %d of %d", config_id, num_configs);
	st->SetWindowText( buf );
}

void CDB2DSMEDlg::OnView() 
{
	CEdit* edt = (CEdit *)GetDlgItem(IDC_CONFIG_NUM);
	CString str; 

	edt->GetWindowText(str);
	int config_id = atoi(str);
	if (config_id < 0 || config_id >= num_configs) return;

	map<int, int> alt_assignment;
	MapConfiguration(config_id, alt_assignment);
	FillConfigTree( (CTreeCtrl *)GetDlgItem(IDC_CONFIG_TREE), alt_assignment);

	CStatic *st = (CStatic *)GetDlgItem(IDC_STATIC);
	CString buf; buf.Format("Displaying Configuration %d of %d", config_id, num_configs);
	st->SetWindowText( buf );
	
}

void CDB2DSMEDlg::MapConfiguration(int config_id, map<int, int>& alt_assignments)
{
	set<DesertIfaceBack::Configuration>::iterator cp = in_configs.begin();
	{ for(int i=0; i<config_id; i++, cp++); }
	if (cp == in_configs.end()) 
	{
		CString msg; msg.Format("%d: no such configuration", config_id);
		AfxMessageBox(msg, MB_ICONSTOP);
		return;
	}

	DesertIfaceBack::Configuration cfg = *cp;
	try	{
		set<DesertIfaceBack::AlternativeAssignment> assgns = cfg.AlternativeAssignment_kind_children();
		for(set<DesertIfaceBack::AlternativeAssignment>::iterator i=assgns.begin(); i!=assgns.end(); i++)
		{
			DesertIfaceBack::AlternativeAssignment assn = *i;
			DesertIfaceBack::Element alt = assn.alternative_end();
			DesertIfaceBack::Element alt_of = assn.alternative_of_end();
			alt_assignments[(int)alt_of.externalID()] = (int)alt.externalID();
		}
	} catch (udm_exception e) {
		AfxMessageBox(e.what());
	}
}

void CDB2DSMEDlg::FillConfigTree(CTreeCtrl *tree, map<int, int>& alt_assignments)
{
	tree->DeleteAllItems();

    HTREEITEM hti = tree->InsertItem(
		TVIF_TEXT | TVIF_PARAM | TVIF_STATE, // mask

//		dsme_file,
		document_name.c_str(),

		0, 0, // image, selected image
		TVIS_EXPANDED, TVIS_EXPANDED, // state, state mask
		(LPARAM)(-1), // lparam
		TVI_ROOT,
		TVI_LAST); // where to insert

	set<DSME::SignalFlow> dsme_sfs = in_root.SignalFlow_kind_children();
	for(set<DSME::SignalFlow>::iterator i=dsme_sfs.begin(); i!=dsme_sfs.end(); i++)
	{
		DSME::SignalFlow dsme_sf = *i;
		set<DSME::Base> dsme_children = dsme_sf.Base_kind_children();
		for(set<DSME::Base>::iterator j=dsme_children.begin(); j!=dsme_children.end(); j++)
		{
			DSME::Base dsme_child = *j;
			FillConfigTree(tree, alt_assignments, dsme_child, hti);
		}
	}
}

void CDB2DSMEDlg::FillConfigTree(CTreeCtrl *tree, map<int, int>& alt_assignments, DSME::Base& in_this, HTREEITEM hparent)
{
    HTREEITEM hti = tree->InsertItem(
		TVIF_TEXT | TVIF_PARAM | TVIF_STATE, // mask
		string(in_this.name()).c_str(),
		0, 0, // image, selected image
		TVIS_EXPANDED, TVIS_EXPANDED, // state, state mask
		(LPARAM)((int)in_this.ID()), // lparam
		hparent,
		TVI_LAST); // where to insert

	if (Udm::IsDerivedFrom(in_this.type(), DSME::Container::meta))
	{
		int assn;
		bool is_alt = false;
		if (in_this.type() == DSME::Alternative::meta)
		{
			map<int, int>::iterator itr = alt_assignments.find( (int)in_this.ID() );
			if (itr == alt_assignments.end())
			{
				CString msg; msg.Format("Alternative %s has no assignment", string(in_this.name()).c_str());
				AfxMessageBox(msg);
				// pick the first one
				itr = alt_assignments.begin();
			}
			assn = (*itr).second;
			is_alt = true;
		}

		DSME::Container in_this_c = DSME::Container::Cast(in_this);
		set<DSME::Base> children = in_this_c.Base_kind_children();
		for(set<DSME::Base>::iterator i=children.begin(); i!=children.end(); i++)
		{
			DSME::Base child = *i;
			if (!is_alt || (assn == child.ID())) 
				FillConfigTree(tree, alt_assignments, child, hti);
		}
	}
}

static char name_buf[64];

void CDB2DSMEDlg::GenerateConfig(int config_id, map<int, int>& alt_assignments)
{
	// prepare output file name
//	string ofn(dsme_file);
//	size_t extpos = ofn.rfind('.');
//	ofn.erase(extpos);

	string ofn(document_name);

	sprintf(name_buf, "%s_c%d", ofn.c_str(), config_id);
	ofn = string(name_buf) + string(".mga");


	myToolAdaptor ta("DB2DSME_TOOL", __argc, __argv);
	UdmCORBA::CORBADataNetwork *out_dn = ta.getDatanetwork(DSME::diagram, "DSME", "1.0");
	out_dn->CreateNew((string)"__temp_" + ofn + (string)".mem", "DSME", DSME::RootFolder::meta, Udm::CHANGES_LOST_DEFAULT);
	
	
//	UdmGme::GmeDataNetwork out_dn(DSME::diagram);
//	out_dn.CreateNew(ofn, "DSME", DSME::RootFolder::meta, Udm::CHANGES_PERSIST_ALWAYS);


	DSME::RootFolder out_root = DSME::RootFolder::Cast(out_dn->GetRootObject());
	out_root.name() = name_buf;
	out_root.prjName() = in_root.prjName();

	set<DSME::SignalFlow> in_sfs = in_root.SignalFlow_kind_children();
	for(set<DSME::SignalFlow>::iterator i=in_sfs.begin(); i!=in_sfs.end(); i++)
	{
		DSME::SignalFlow in_sf = *i;
		DSME::SignalFlow out_sf = DSME::SignalFlow::Create(out_root);
		out_sf.name() = in_sf.name();

		set<DSME::Base> in_children = in_sf.Base_kind_children();
		for(set<DSME::Base>::iterator j=in_children.begin(); j!=in_children.end(); j++)
		{
			DSME::Base in_child = *j;
			GenerateConfig(alt_assignments, in_child, out_sf);
		}
	}

//	out_dn.CloseWithUpdate();

	if (IDYES == AfxMessageBox("Do you want to publish the DSME output?", MB_YESNO | MB_ICONQUESTION)) {

		out_dn->copyAdditionalFilesFrom(dn_back);

		out_dn->publishDocument(document_name.c_str(), document_version.c_str(), "After the DB2DSME Tool translation", document_keepAlive);

//		addStringFetchDlg("Desert output is sent.");
//		addStringFetchDlg("");
	}

	
	out_dn->CloseNoUpdate();
	out_dn->release();

	ta.logout();


	baseMap.clear();
	altMap.clear();
	portMap.clear();
}

void CDB2DSMEDlg::GenerateConfig(map<int, int>& alt_assignments, DSME::Base& in_this, Udm::Object& out_parent, Udm::Object& in_parent)
{
	DSME::Base out_this;

	if (in_this.type() == DSME::Primitive::meta)
	{
		DSME::Primitive in_prim = DSME::Primitive::Cast(in_this);
		DSME::Primitive out_prim = DSME::Primitive::Create(out_parent);
		out_prim.name() = in_prim.name();
		out_prim.SimulinkFile() = in_prim.SimulinkFile();
		out_prim.SimulinkModel() = in_prim.SimulinkModel();
		out_this = DSME::Base::Cast(out_prim);
	}
	else if (in_this.type() == DSME::Compound::meta)
	{
		DSME::Compound in_comp = DSME::Compound::Cast(in_this);
		DSME::Compound out_comp = DSME::Compound::Create(out_parent);
		out_this = DSME::Base::Cast(out_comp);

		set<DSME::Base> in_children = in_comp.Base_kind_children();
		for(set<DSME::Base>::iterator i=in_children.begin(); i!=in_children.end(); i++)
		{
			DSME::Base in_child = *i;
			GenerateConfig( alt_assignments, in_child, out_comp);
		}
	}
	else if (in_this.type() == DSME::Alternative::meta)
	{
		map<int, int>::iterator itr = alt_assignments.find( (int)in_this.ID() );
		if (itr == alt_assignments.end())
		{
			CString msg; msg.Format("Alternative %s has no assignment", string(in_this.name()).c_str());
			AfxMessageBox(msg);
			// found no assignments -- pick the first one
			itr = alt_assignments.begin();
		}
		int assn = (*itr).second;

		DSME::Alternative in_alt = DSME::Alternative::Cast(in_this);
		set<DSME::Base> in_children = in_alt.Base_kind_children();
		for(set<DSME::Base>::iterator i=in_children.begin(); i!=in_children.end(); i++)
		{
			DSME::Base child = *i;
			if (assn == child.ID())
			{
				altMap[in_alt] = child;
				GenerateConfig( alt_assignments, child, out_parent, in_this);
				return;
			}
		}
	}

	// map objects
	baseMap[in_this] = out_this;

	// set attribute
	out_this.name() = in_this.name();
	out_this.DefFile() = in_this.DefFile();

	if (in_parent != Udm::null)
	{
		DSME::Base in_pbase = DSME::Base::Cast(in_parent);
		out_this.position() = in_pbase.position();
	}
	else
		out_this.position() = in_this.position();

	// create ports 
	{
		// input ports
		set<DSME::InputPort> in_ins = in_this.InputPort_kind_children();
		for(set<DSME::InputPort>::iterator i=in_ins.begin(); i!=in_ins.end(); i++)
		{
			DSME::InputPort in_in = *i;
			DSME::InputPort out_in = DSME::InputPort::Create(out_this);
			out_in.name() = in_in.name();
			out_in.position() = in_in.position();
			portMap[in_in] = out_in;
		}
	}
	{
		// output ports
		set<DSME::OutputPort> in_outs = in_this.OutputPort_kind_children();
		for(set<DSME::OutputPort>::iterator i=in_outs.begin(); i!=in_outs.end(); i++)
		{
			DSME::OutputPort in_out = *i;
			DSME::OutputPort out_out = DSME::OutputPort::Create(out_this);
			out_out.name() = in_out.name();
			out_out.position() = in_out.position();
			portMap[in_out] = out_out;
		}
	}
	// create muxes/demuxes/stars
	{
		set<DSME::Mux> mxs = in_this.Mux_kind_children();
		for(set<DSME::Mux>::iterator i=mxs.begin(); i!=mxs.end(); i++)
		{
			DSME::Mux in_mx = *i;
			DSME::Mux out_mx = DSME::Mux::Create(out_this);
			out_mx.name() = in_mx.name();
			out_mx.position() = in_mx.position();
			portMap[in_mx] = out_mx;
		}
	}
	{
		set<DSME::Demux> dxs = in_this.Demux_kind_children();
		for(set<DSME::Demux>::iterator i=dxs.begin(); i!=dxs.end(); i++)
		{
			DSME::Demux in_dx = *i;
			DSME::Demux out_dx = DSME::Demux::Create(out_this);
			out_dx.name() = in_dx.name();
			out_dx.position() = in_dx.position();
			portMap[in_dx] = out_dx;
		}
	}
	{
		set<DSME::StarConnector> scs=in_this.StarConnector_kind_children();
		for(set<DSME::StarConnector>::iterator i=scs.begin(); i!=scs.end(); i++)
		{
			DSME::StarConnector in_sc = *i;
			DSME::StarConnector out_sc = DSME::StarConnector::Create(out_this);
			out_sc.name() = in_sc.name();
			out_sc.position() = in_sc.position();
			portMap[in_sc] = out_sc;
		}
	}
	// create signals
	set<DSME::Signal> sigs = in_this.Signal_kind_children();
	for(set<DSME::Signal>::iterator sigi=sigs.begin(); sigi!=sigs.end(); sigi++)
	{
		DSME::Signal in_sig = *sigi;
		DSME::Signal out_sig = DSME::Signal::Create(out_this);
		DSME::ConnBase in_sco = in_sig.srcSignal_end();
		DSME::ConnBase in_dco = in_sig.dstSignal_end();
		DSME::ConnBase out_sco = portMap[in_sco];
		DSME::ConnBase out_dco = portMap[in_dco];
		// sco or dco can be null only when sco or dco is a port contained in an alt
		if (out_sco == Udm::null)
		{
			ASSERT(Udm::IsDerivedFrom(in_sco.type(), DSME::Port::meta));
			DSME::Port in_sp = DSME::Port::Cast(in_sco);
			DSME::Base in_spar = in_sp.Base_parent();
			ASSERT(in_spar.type() == DSME::Alternative::meta);
			DSME::Alternative in_alt = DSME::Alternative::Cast(in_spar);
			DSME::Base in_sel_alt = altMap[in_alt];
			set<DSME::Signal> alt_sigs = in_sp.srcSignal();
			for(set<DSME::Signal>::iterator asi=alt_sigs.begin(); asi!=alt_sigs.end(); asi++)
			{
				DSME::Signal a_sig = (*asi);
				DSME::Port a_port = DSME::Port::Cast(a_sig.srcSignal_end());
				DSME::Base a_par = a_port.Base_parent();
				if (a_par == in_sel_alt)
				{
					out_sco = portMap[a_port];
					break;
				}
			}
		}
		if (out_dco == Udm::null)
		{
			DSME::Port in_dp = DSME::Port::Cast(in_dco);
			DSME::Base in_dpar = in_dp.Base_parent();
			ASSERT(in_dpar.type() == DSME::Alternative::meta);
			DSME::Alternative in_alt = DSME::Alternative::Cast(in_dpar);
			DSME::Base in_sel_alt = altMap[in_alt];
			set<DSME::Signal> alt_sigs = in_dp.dstSignal();
			for(set<DSME::Signal>::iterator asi=alt_sigs.begin(); asi!=alt_sigs.end(); asi++)
			{
				DSME::Signal a_sig = (*asi);
				DSME::Port a_port = DSME::Port::Cast(a_sig.dstSignal_end());
				DSME::Base a_par = a_port.Base_parent();
				if (a_par == in_sel_alt)
				{
					out_dco = portMap[a_port];
					break;
				}
			}
		}

		ASSERT(out_sco != Udm::null);
		ASSERT(out_dco != Udm::null);
		out_sig.srcSignal_end() = out_sco;
		out_sig.dstSignal_end() = out_dco;
	}
}

