#ifndef desertdll_H
#define desertdll_H

// prototype of the desert dll exported functions

#define DLL_DECL __declspec (dllimport)

//error handling with exceptions

class CDesertException : public CException
{
	bool fatal;
	char *what;

public:
	DECLARE_DYNAMIC(CDesertException)				//MFC inheritence

	//different constructors
	CDesertException();			
	CDesertException(bool _fatal);

	CDesertException(const char * _what);
	CDesertException(const CString _what);

	
	CDesertException(bool _fatal, const char * _what);
	CDesertException(bool _fatal, const CString _what);
	
	BOOL GetErrorMessage( LPTSTR lpszError, UINT nMaxError, PUINT pnHelpContext = NULL)	;
	bool Fatal();
	~CDesertException();						

};




DLL_DECL void DesertInit(const char *prjName);
DLL_DECL void * DesertFinit(bool noError);
/*
DLL_DECL void * DesertFinit(bool noError, double& dspSize, long& repSize, long& encSize);
DLL_DECL void * DesertFinit(bool noError, double& dspSize, long& repSize, long& encSize, long& consSize, long& prunedRepSize, double& prunedSpaceSize);
*/
DLL_DECL long CreateSpace(const char *name);
DLL_DECL long CreateElement(const char *name, long space_or_domain, short decomp, long parent, long ext);
DLL_DECL long CreateNaturalDomain(const char *name, int mx, int mn);
DLL_DECL long CreateCustomDomain(const char *name);
DLL_DECL long CreateConstantProperty(const char *name, const char *pcfn, long owner, long domain, int value);
DLL_DECL long CreateVariableProperty(const char *name, const char *pcfn, long owner, long domain);
DLL_DECL long CreateRelation(long context, long source, long destination);
DLL_DECL long CreateConstraintSet(const char *name);
DLL_DECL long CreateConstraint(const char *name, long constraintSet, long context, const char *text);
DLL_DECL long AddtoVariableProperty(const char *name, long owner, long value, long domain);
DLL_DECL long AddtoVariableProperty(long property, long owner, long value, long domain);
DLL_DECL long AddtoVariableProperty(const char *name, const char *n, long owner, long value, long domain);
DLL_DECL long AddtoVariableProperty(long property, const char *n, long owner, long value, long domain);


#endif // #ifndef desertdll_H
