#ifndef INTERACTION_GENERATOR_H
#define INTERACTION_GENERATOR_H

#include "UdmDom.h"
#include "UdmGme.h"
#include "UmlExt.h"
#include "UdmUtil.h"

#include "AIF.h"
#include "ESML.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <list.h>

class InteractionGenerator
{
	typedef map<Udm::Object, AIF::AIFObject> ESML2AIF;
public:
	set<Udm::Object> esmlComRefs;
	map<Udm::Object, ESML2AIF > esmlObjs;
	map<ESML::Timer, AIF::TimerComponent> timerMap;
	map<ESML::ComponentType, ESML::ComponentType> proxy_master;
	map<ESML::PublishPort, ESML::EventType> pubEvent;

	ESML::RootFolder esmlRootFdr;
	AIF::Interactions aifInteraction;

	InteractionGenerator(AIF::System aifSystem);
	void CreateAIFObject(AIF::AIFObject aif_obj, string objName);
	AIF::AIFObject GetAIFObject(Udm::Object esmlObj, ESML::Processor esmlProcessor);
	AIF::AIFObject GetAIFObject(Udm::Object esmlObj, Udm::Object esmlComRef);
	bool GetESMLComponent(Udm::Object esmlComRef, ESML::ComponentType& comType);
	bool IsEnable(ESML::ComponentType esmlCom);
	ESML::Processor GetProcessor(Udm::Object esmlComRef);
	void PublishEventPass(ESML::PublishPort esmlPort, Udm::Object comRef);
	void SubscribePass(ESML::SubscribePort subPort, Udm::Object comRef);
	void InvocationPass(ESML::Receptacle recep, Udm::Object comRef);
	void GenerateInteractionDiagram();
	AIF::Link GetAIFLink(AIF::Processor p1, AIF::Processor p2);
	void InsertESMLObjEntry(Udm::Object esmlObj, AIF::AIFObject aifObj, Udm::Object esmlComRef);
};

#endif //INTERACTION_GENERATOR_H