
#include <sstream>

#include "GenESML2PRISMRules.h"
#include "ESML2PRISMRules.h"
UDM_USE_DOM
UDM_USE_MGA

#include "UdmCORBA.h"
#include "UdmCORBA_Logger.h"
Logger alogger = Logger("Translator_PRISM2ESML");



#include "Uml.h"

//#include "..\etc\ESMLVersion.h"




	class myTranslator : public UdmCORBA::Translator {

	public:
		myTranslator(const Udm::UdmDiagram &from_metainfo, const char *from_name, const char *from_version, const Uml::Class &from_rootclass,
				const Udm::UdmDiagram &to_metainfo, char *to_name, char *to_version, const Uml::Class &to_rootclass,
				int argc, char **argv, Logger *logger)
				: Translator(from_metainfo, from_name, from_version, from_rootclass, 
							to_metainfo, to_name, to_version, to_rootclass, 
							argc, argv, logger) {};


  void notify(const char *name, const char *version, const char *remarks, const unsigned long numOfDocs) 
  {

    std::string fromID("from");
    std::string toID("to");

    std::vector< Udm::StaticDataNetworkSpecifier> dnsvec;

		Udm::StaticDataNetworkSpecifier sdns_ESML_847(fromID , fromDN);
		dnsvec.push_back( sdns_ESML_847);

		Udm::StaticDataNetworkSpecifier sdns_PRISM_844(toID , toDN);
		dnsvec.push_back( sdns_PRISM_844);

		// Create the project
		Udm::StaticUdmProject prj( dnsvec, ESML2PRISMRules::diagram);

		Udm::DataNetwork& eSML_ref_848= prj.GetDataNetwork( fromID);
		Udm::DataNetwork& pRISM_ref_845= prj.GetDataNetwork( toID);

		Packets_t eSMLs_1;
		Packets_t eSCMIns_3;
		// get objects from DNs
		PRISM::ESCM rootPRISM_849= PRISM::ESCM::Cast( pRISM_ref_845.GetRootObject());
		eSCMIns_3.push_back( rootPRISM_849);
		ESML::RootFolder rootESML_84a= ESML::RootFolder::Cast( eSML_ref_848.GetRootObject());
		eSMLs_1.push_back( rootESML_84a);
		// transformation
		ESML2PRISM_0 eSML2PRISM_0;
		eSML2PRISM_0( eSCMIns_3, eSMLs_1);

		// Close the project
		prj.Close();
  	publish(name, version, "After the ESML->PRISM translation");

	}
};

//========================================
int main(int argc, char **argv)
{

try 
{

  myTranslator tr(
						ESML::diagram, "ESML", "1.0", ESML::RootFolder::meta, 
            PRISM::diagram, "PRISM", "1.3", PRISM::ESCM::meta, 
						argc, argv, &alogger);


		//tr.addFromDN(ESML::diagram, "ESML", "1.0", ESML::RootFolder::meta);
		tr.run();
}
catch (udm_exception &e)
{
		cout << e.what() << endl;
		alogger.log(1,  "Error", e.what());
}
catch (udmcorba_exception &e)
{
		cout << e.what() << endl;
		alogger.log(1,  "Error", e.what());
}
catch (...)
{
		cerr << "Fatal exception" << endl;
		alogger.log(1,  "Error", "Fatal exception");
}	
	return 0;
}





