#include "test.h"
#include "UdmDom.h"
#include "UdmCORBA.h"
#include "UdmCORBA_Logger.h"
Logger logger = Logger("Translator_Test");

using namespace test;

class myTranslator : public UdmCORBA::Translator {

public:
	myTranslator(const Udm::UdmDiagram &from_metainfo, const char *from_name, const char *from_version, const Uml::Class &from_rootclass,
			const Udm::UdmDiagram &to_metainfo, const char *to_name, const char *to_version, const Uml::Class &to_rootclass,
			int argc, char **argv, Logger *logger)
			: Translator(from_metainfo, from_name, from_version, from_rootclass, 
						to_metainfo, to_name, to_version, to_rootclass, 
						argc, argv, logger) {};


	void notify(const char *name, const char *version, const char *remarks, const unsigned long numOfDocs) {
		Root from_root = Root::Cast(fromDN->GetRootObject());
		Root to_root = Root::Cast(toDN->GetRootObject());

		to_root.count() = from_root.count();
		set<A> as = from_root.A_kind_children();
		for(set<A>::iterator i=as.begin(); i!=as.end(); i++) {
			A a = A::Create(to_root);
			string name = (*i).name();
			name.append("_copy");
			a.name() = name;
		}

		toDN->copyAdditionalFilesFrom(fromDN);

		publish(name, version, "After the TEST1.0->TEST1.0 translation");
	}

};

int main(int argc, char* argv[]) {

	try {
		myTranslator tr(diagram, "TEST", "1.0", Root::meta, 
						diagram, "TEST", "1.0", Root::meta, 
						argc, argv, &logger);
		tr.run();
	} catch (udm_exception &e) {
		cout << e.what() << endl;
		logger.log(1,  "Error", e.what());
	} catch (udmcorba_exception &e) {
		cout << e.what() << endl;
		logger.log(1,  "Error", e.what());
	} catch (...) {
		cerr << "Fatal exception" << endl;
		logger.log(1,  "Error", "Fatal exception");
	}	

	return 0;
}
